Package: betaHMM
Type: Package
Title: A Hidden Markov Model Approach for Identifying Differentially
        Methylated Sites and Regions for Beta-Valued DNA Methylation
        Data
Version: 1.9.0
Authors@R: c(person("Koyel","Majumdar",email="koyelmajumdar.phdresearch@gmail.com",
        role=c("cre","aut"),comment = c(ORCID = "0000-0001-6469-488X")),
        person("Romina","Silva",
        role="aut"),
        person("Antoinette Sabrina","Perry",
        role="aut"),
        person("Ronald William","Watson",
        role="aut"),
        person("Isobel Claire","Gorley",email="claire.gormley@ucd.ie",
        role="aut", comment=c(ORCID="0000-0001-7713-681X")),
        person("Thomas Brendan","Murphy",email="brendan.murphy@ucd.ie", 
        role="aut",comment=c(ORCID="0000-0002-5668-7046")),
        person("Florence","Jaffrezic",email="florence.jaffrezic@inrae.fr",
        role="aut"),
        person("Andrea","Rau",email="andrea.rau@inrae.fr",role="aut",
        comment = c(ORCID = "0000-0001-6469-488X")))
Description: A novel approach utilizing a homogeneous hidden Markov model. And
            effectively model untransformed beta values. To identify DMCs while 
            considering the spatial. Correlation of the adjacent CpG sites.
License: GPL-3
Encoding: UTF-8
Imports: stats, ggplot2, scales, methods, pROC, foreach, doParallel,
        parallel, cowplot, dplyr, tidyr, tidyselect, stringr, utils
Depends: R (>= 4.3.0), SummarizedExperiment, S4Vectors, GenomicRanges
RoxygenNote: 7.2.3
biocViews: DNAMethylation, DifferentialMethylation, ImmunoOncology,
        BiomedicalInformatics, MethylationArray, Software,
        MultipleComparison, Sequencing, Spatial, Coverage, GeneTarget,
        HiddenMarkovModel, Microarray
Suggests: rmarkdown, knitr, testthat (>= 3.0.0), BiocStyle
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/betaHMM
git_branch: devel
git_last_commit: a813975
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:30:46 UTC; biocbuild
Author: Koyel Majumdar [cre, aut] (ORCID:
    <https://orcid.org/0000-0001-6469-488X>),
  Romina Silva [aut],
  Antoinette Sabrina Perry [aut],
  Ronald William Watson [aut],
  Isobel Claire Gorley [aut] (ORCID:
    <https://orcid.org/0000-0001-7713-681X>),
  Thomas Brendan Murphy [aut] (ORCID:
    <https://orcid.org/0000-0002-5668-7046>),
  Florence Jaffrezic [aut],
  Andrea Rau [aut] (ORCID: <https://orcid.org/0000-0001-6469-488X>)
Maintainer: Koyel Majumdar <koyelmajumdar.phdresearch@gmail.com>

# betaHMM: a hidden Markov model to identify differential methylation sites and
 regions from beta-valued methylation data 

Authors: KOYEL MAJUMDAR, ISOBEL CLAIRE GORMLEY, THOMAS BRENDAN MURPHY, ROMINA
SILVA, ANTOINETTE SABRINA PERRY, RONALD WILLIAM WATSON,
FLORENCE JAFFR ́EZIC, ANDREA RAU

A hidden Markov model approach for identifying differentially methylated 
sites and regions for beta-valued DNA methylation data. The workflow consists
of 3 main functions:
\itemize{
\item betaHMM: to estimate the hidden Markov model parameters and the 
hidden methylation states of each CpG sites.
\item dmc_identification: uses the output from the above function to identify
CpG sites that are mostly differentially methylated between DNA samples 
collected from \eqn{R} conditions.
\item dmr_identification: to identify adjacent DMCs forming DMRs.
}

A typical call to betaHMM to apply the Baum-Welch algorithm and Viterbi 
algorithm takes the following form:
```
library(betaHMM)
### read the methylation file and annotation file
data(sample_methylation_file)
head(sample_methylation_file)
data(sample_annotation_file)
head(sample_annotation_file)
betaHMM_out <- betaHMM(sample_methylation_file,
                                sample_annotation_file,
                                M = 3,
                                N = 4,
                                R = 2,
                                parallel_process = FALSE,
                                seed = 321,
                                treatment_group = c("Benign","Tumour"))
```
where `M` represents the number of methylation state in a DNA sample, `N`
represents the number of subjects or DNA replicates, `R` represents the number
of conditions from where DNA is extracted.

A typical call to dmc_identification takes the following form:
```
dmc_out <- dmc_identification(betaHMM_out)
dmc_df <- assay(dmc_out)
```

A typical call to dmr_identification takes the following form:
```
dmr_out <- dmr_identification(dmc_out)
dmr_df <- assay(dmr_out)
```


The output of the `betaHMM` function is an
S4 object of class `betaHMMResults`, the output of the `dmc_identification`
function is an S4 object of class `dmcResults` and the output of the 
`dmr_identification` function is an S4 object of class `dmrResults` 
on which standard `plot` and `summary` functions can be directly applied; 
the former uses functionalities from the 
[ggplot2]( https://cran.r-project.org/package=ggplot2) package.

### Reference


### License

The betaHMM package is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License, version 3, 
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but without 
any warranty; without even the implied warranty of merchantability or fitness 
for a particular purpose. See the GNU General Public License for more details.

A copy of the GNU General Public License, version 3, 
is available at http://www.r-project.org/Licenses/GPL-3.

#'
#' @rdname plot
#' @aliases
#' plot
#' plot-methods
#' plot,threshold_Results-method
#'
#' @export
#' @param x An object of class
#' \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}/
#' \code{\link[betaHMM:dmcResults]{dmcResults}}/
#' \code{\link[betaHMM:dmcResults]{threshold_Results}} object.
#' @param plot_threshold The "TRUE" option displays the threshold points in the
#' graph for the 3 state betaHMM model (default = "FALSE").
#' @param title The title that the user wants to display.
#' If no title is to be displayed the default is 'NULL'.
#' @param ... Other graphics parameters.
#' @return The function displays the plot for the estimated shape parameters
#' and threshold for the methylation states in a single DNA treatment condition
#' from the \code{\link[betaHMM:threshold_Results]{threshold_Results}} object.
#'
#' @importFrom ggplot2 ggplot aes annotate ggplot_build geom_line labs
#' @importFrom ggplot2 scale_color_manual geom_vline
#' @importFrom scales seq_gradient_pal
#' @importFrom stats dbeta
setMethod(f = "plot", signature(x = "threshold_Results"),
            definition = function(x, plot_threshold=TRUE,title = NULL, ...) {

    graph_objects <- c()

    object <- x
    graph_objects <- thresholdGlobalplots(object,plot_threshold=plot_threshold,
                                            title = title, ...)
    return(graph_objects)
})

thresholdGlobalplots <- function(x, plot_threshold=TRUE,title = NULL, ...) {
    txt <- ifelse(is.null(title), "", title)
    data <- as.data.frame(annotatedData(x))
    df_plot <- subset(data, select = -c(IlmnID))
    data_x <- sort(df_plot[, 1])
    K <- K(x)
    prop <- as.numeric(table(hidden_states(x)))/nrow(data)
    data_th_plot <- matrix(data = NA, nrow = 1, ncol = 3)
    data_th_plot <- as.data.frame(data_th_plot)
    colnames(data_th_plot) <- c("beta_value", "density", "Cluster")
    phi_complete <- model_parameters(x)$phi
    alpha <- phi_complete[[1]]
    delta <- phi_complete[[2]]
    data_th_plot_list <- lapply(seq(1, K), function(i) {
        beta_value <- data_x
        Cluster <- rep(i, length(data_x))
        density <- prop[i] * dbeta(data_x, alpha[i], delta[i])
        data.frame(beta_value = beta_value,density = density,Cluster = Cluster)
    })
    data_th_plot <- do.call(rbind, data_th_plot_list)
    data_th_plot <- as.data.frame(data_th_plot)
    data_th_plot <- data_th_plot[-1, ]
    data_th_plot$Cluster <- as.factor(data_th_plot$Cluster)
    plot_graph <- ggplot(data_th_plot) + geom_line(aes(beta_value,
                                                       density,
                                                       color = Cluster),
                                                   linetype = "solid") +
        labs(x="Beta value",y="Density",title = txt, color = "Hidden States")
    if (K == 3) {
        colours <- c("chartreuse3", "magenta", "cyan3")
        plot_graph <- plot_graph + scale_color_manual(values = colours)}
    p.data <- ggplot_build(plot_graph)$data[[1]]
    p.text <- lapply(split(p.data, f = p.data$group), function(df) {
        df[which.max(df$y), ]})
    p.text <- do.call(rbind, p.text)
    p.text$prop <- prop
    plot_graph <- plot_graph + annotate("text", x = p.text$x, y = 0.2,
                                        label = sprintf("%.3f", p.text$prop),
                                        colour = p.text$colour, vjust = 0)
    if(plot_threshold==TRUE)
    {
        if (!is.null(plot_graph)) {
            th_plot <- as.vector(unlist(threshold(x)))
            ano_th <- th_plot - 0.02 }
        num <- sort(p.text$y)
        ano_y <- num[length(num)] - 0.1
        plot_graph <- plot_graph + geom_vline(xintercept = th_plot,
                                              linetype = "dotted") +
            annotate("text", x = ano_th, y = ano_y,
                     label = th_plot, angle = 90)
    }
    return(plot_graph)}

#' @title Area under the curve method for calculating dissimilarities between
#' estimated distributions
#' @description The function is used to calculate the dissimilarity between the
#' cumulative distributions estimated in each hidden state.
#' @keywords internal
#' @param K Number of hidden states estimated.
#' @param M Number of methylation states to be identified in a single DNA
#' sample.
#' @param N Number of patients or DNA sample replicates collected for each
#' treatment group.
#' @param R Number of treatment groups (For. eg: Benign and Tumour).
#' @param A The transition matrix for hidden states in the betaHMM model.
#' @param tau The initial distribution for hidden states in the betaHMM model.
#' @param phi The shape parameters estimated for the observed data and the
#' estimated hidden states in the betaHMM model.
#' @return A dataframe returning the hidden state, the AUC value and the
#' distributions which resulted in highest AUC value calculated
#' for the corresponding hidden state.
#' @importFrom pROC auc
#' @importFrom stats rbeta
#'
AUC_DM_analysis <- function(M, N, R, K, tau, A, phi) {
    alpha <- t(phi$sp_1)
    delta <- t(phi$sp_2)
    comb <- factorial(R)/(factorial(2) * factorial(R - 2))
    auc_vec <- vector()
    auc_final <- vector()
    comp_final <- vector()
    n <- 1000
    auc_mat <- matrix(NA, nrow = K, ncol = comb)
    text <- vector()
    process_j <- function(j, R, alpha, delta) {
        shape_1 <- alpha[j, seq_len(R), drop = FALSE]
        shape_2 <- delta[j, seq_len(R), drop = FALSE]
        i <- rep(seq_len(R-1), each = R - 1)
        k <- rep((i + 1):R, each = R - 1)
        group_1 <- rbeta(n * (R - 1) * (R - 1), shape1 = shape_1[i],
                         shape2 = shape_2[i])
        group_2 <- rbeta(n * (R - 1) * (R - 1), shape1 = shape_1[k],
                         shape2 = shape_2[k])
        auc_dat <- data.frame(
            predictor = c(group_1, group_2),
            response = factor(rep(0:1, each = n * (R - 1) * (R - 1))))
        auc_values <- auc(predictor = auc_dat$predictor,
                          response = auc_dat$response, quiet = TRUE)
        auc_vec <- unlist(auc_values)
        max_index <- which.max(auc_vec)
        auc_final <- auc_vec[max_index]
        comp_final <- paste(i[max_index], "-->", k[max_index])
        return(c(auc_final,comp_final))
    }
    indices <- seq(1, K)
    result<-lapply(indices, process_j, R = R, alpha = alpha, delta = delta)
    result<-do.call(rbind,result)
    auc_final<-as.numeric(as.vector(result[,1]))
    comp_final<-result[,2]
    auc_df <- as.data.frame(cbind(as.character(seq(1, K)),
                                  as.numeric(round(auc_final, 3)),
                                  comp_final))
    auc_df <- auc_df[order(auc_df$V2), , drop=FALSE]
    auc_df <- t(auc_df)
    rownames(auc_df) <- c("State", "AUC","DM_Conditions")
    return(auc_df)
}

#' @title Backward algorithm
#' @description Computes the backward probabilities for \eqn{K} hidden states
#' using the initial distribution, transition matrix and distribution
#' parameters.
#' @keywords internal
#' @param probabilities A matrix containing the marginal probability
#' distribution of the \eqn{K} hidden states within the Markov model.
#' @param trained_params A list containing the initialised shape parameters for
#' the betaHMM model (initial distribution, transition matrix, shape parameters
#' for the observed data).
#' @return A list containing:
#' \itemize{
#' \item log_beta - A matrix of dimension \eqn{C*K} (where \eqn{C} is the
#' number of CpG sites and \eqn{K} is the number of hidden states) containing
#' the logarithmized backward probabilities.
#' \item scaled_logL - The log-likelihood calculated using the backward
#' probabilities.
#' }

backward <- function(probabilities, trained_params) {
    C <- nrow(probabilities)
    K <- ncol(probabilities)
    log_beta <- matrix(0, nrow = C, ncol = K)
    log_beta[C, ] <- rep(0, K)
    beta <- rep(1/K, K)
    scaled_logL <- log(K)
    for (i in (C - 1):1) {
        beta <- trained_params$A %*% (probabilities[i + 1, ] * beta)
        log_beta[i, ] <- log(beta) + scaled_logL
        sum_of_beta <- sum(beta)
        beta <- beta/sum_of_beta
        scaled_logL <- scaled_logL + log(sum_of_beta)
    }
    return(list(log_beta = log_beta, scaled_logL = scaled_logL))
}

globalVariables(c("x", "Cluster"))
#' @keywords internal
#' @importFrom ggplot2 ggplot geom_text aes geom_density ggtitle
#' @importFrom ggplot2 scale_colour_manual scale_fill_gradient facet_wrap theme
#' @importFrom ggplot2 geom_boxplot coord_cartesian geom_hline labs xlab ylab
#' @importFrom ggplot2 scale_linetype_manual guide_legend element_text
#' @importFrom stats kmeans sd dbeta density
#' @importFrom scales seq_gradient_pal

initialize_parameters_th <- function(data, M, N, R, seed = NULL) {
    K <- M
    A <- 0.6 * diag(K) + rep(0.05/K, K)  ## transmission probabilities
    tau <- rep(1/K, K)  ## initial mixing proportions
    data <- as.data.frame(data)
    for (i in seq(1, ncol(data))) {
        data[, i] <- as.numeric(data[, i])
    }
    data <- as.matrix(data)
    k_cluster <- kmeans(data, M)
    mem <- k_cluster$cluster
    data_clust <- cbind(data, mem)
    x <- as.matrix(data_clust)
    mem <- x[, ncol(x), drop=FALSE]
    data_full <- x
    x <- x[, -ncol(x), drop=FALSE]
    C <- nrow(x)
    N <- ncol(x)
    mu <- vapply(seq(1, K), function(k) mean(x[mem == k, ]),numeric(1))
    sigma <- vapply(seq(1, K), function(k) sd(x[mem == k, ]),numeric(1))
    term <- vapply(seq(1, K), function(k) (mu[k]*(1-mu[k])/(sigma[k]^2)) - 1,
                   numeric(1))
    alpha <- mu * term
    beta <- (1 - mu) * term
    alpha <- sort(alpha)
    delta <- sort(beta, decreasing = TRUE)
    alpha[2] <- 1
    delta[2] <- 1
    phi <- list(sp_1 = alpha, sp_2 = delta)
    return(list(A = A, tau = tau, phi = phi))
}



threshold_values <- function(data, tau, phi) {
    threshold_func <- function(data_x, alpha, delta, tau, i,upper_lower) {
        num <- tau[i] * dbeta(data_x, alpha[i], delta[i])
        deno_list <- lapply(seq_along(alpha)[-i], function(j) {
            tau[j] * dbeta(data_x, alpha[j], delta[j])
        })
        deno <- Reduce(`+`, deno_list)
        r <- num/deno
        index <- which(r >= 1)
        if(upper_lower==1){
        l <- data_x[min(index)]}else{
        l <- data_x[max(index)]
        }
        return(l)
    }
    data_x <- sort(data[, 1])
    mode <- as.vector((phi$sp_1 - 1)/(phi$sp_1 + phi$sp_2 - 2))
    cluster <- c(1, 2, 3)
    mode_vec <- cbind(mode, cluster)
    mode_vec <- as.data.frame(mode_vec)
    mode_vec <- mode_vec[order(mode_vec$mode),, drop=FALSE ]
    hypo <- as.numeric(mode_vec[1, 2])
    hyper <- as.numeric(mode_vec[3, 2])
    th_1 <- threshold_func(data_x, phi$sp_1, phi$sp_2, tau, hypo,2)
    th_2 <- threshold_func(data_x, phi$sp_1, phi$sp_2, tau, hyper,1)
    th_vec <- c(th_1, th_2)
    th_new1 <- unique(round(th_vec, 3))

    return(list(thresholds = th_new1))
}

kernel_density_plot <- function(data, hidden_states, auc, C,
                                treatment_group, title_text) {
    data_ggplot <- as.data.frame(data)
    data_ggplot$mem_final <- as.factor(hidden_states)
    colnames(data_ggplot)[length(data_ggplot)] <- "Cluster"
    cols <- ncol(data_ggplot)
    rows <- nrow(data_ggplot)
    data_matrix <- as.matrix(data_ggplot[, seq(1, (cols - 1)), drop=FALSE])
    data_new <- as.vector(data_matrix)
    col_names <- colnames(data_ggplot)
    col_len <- length(col_names)
    Cluster <- vector()
    Patient_sample <- vector()
    result_list <- lapply(seq(1, (col_len - 1)), function(i) {
        temp <- gsub("_", " ", col_names[i])
        ps_names <- rep(temp, rows)
        Cluster <- data_ggplot[, cols, drop=FALSE]
        return(list(Patient_sample = ps_names, Cluster = Cluster))
    })
    Patient_sample <- unlist(lapply(result_list, function(x) x$Patient_sample))
    Cluster <- do.call(rbind, lapply(result_list, function(x) x$Cluster))
    data_plot <- data.frame(data_new = data_new, Cluster = Cluster,
                            Patient_sample = Patient_sample)
    colnames(data_plot) <- c("beta_value", "Cluster", "Patient_Sample")
    data_plot$Cluster <- factor(data_plot$Cluster, levels = auc$State)
    data_plot$Cluster_full <- as.factor(data_plot$Cluster)
    levels(data_plot$Cluster_full) <- auc$label
    color_length <- col_len - 1
    colours_kd <- (seq_gradient_pal(low = "#FFC20A", high = "#0C7BDC",
                                 space = "Lab"))(seq(1, color_length)/
                                                     color_length)
    plot_graph <- ggplot(data_plot) + geom_density(aes(x = beta_value,
                                                       color=Patient_Sample))+
        xlab("Beta Value") +
        ylab("Density") + scale_color_manual("DNA Samples", values = colours_kd) +
        facet_wrap(~factor(Cluster_full, levels = auc$label),
                   scales = "free_y", ) +
        theme(axis.title.x = element_text(size = 10),
              axis.title.y = element_text(size = 10)) +
        ggtitle(title_text)
    cluster_size <- table(hidden_states)
    y <- vapply(auc$State, function(i) {
        max_density <- max(density(data_plot[data_plot$Cluster == i, 1])$y)
        return(max_density)
    }, numeric(1))
    f_labels <- data.frame(Cluster_full = levels(data_plot$Cluster_full),
                           label=as.vector(round((cluster_size[auc$State]/C),
                                                 3)), x = 0.8, y = y)
    plot_graph <- plot_graph + geom_text( aes(x = x, y = y,label = label),
                                          data = f_labels)
    return(plot_graph)
}

fitted_density_plot <- function(phi, hidden_states, auc, R, K, C,
                                treatment_group = NULL, title_text = NULL) {
    vec_C <- 1001
    alpha <- t(phi$sp_1)
    delta <- t(phi$sp_2)
    tau <- round(as.vector(table(hidden_states)/length(hidden_states)), 3)
     vec_x <- seq(0.001, 0.999, length = vec_C)
    combinations <- expand.grid(i = seq(1, R), j = seq(1, K))
    process_combination <- function(i, j, vec_x, tau, alpha, delta,
                                    treatment_group) {
        tmp_vec <- vapply(vec_x, function(x) {
            tau[j] * dbeta(x, alpha[j, i], delta[j, i])
        }, numeric(1))
        data.frame(
            beta = vec_x,
            density = tmp_vec,
            cluster = rep(j, times = length(tmp_vec)),
            sample = rep(treatment_group[i], times = length(tmp_vec))
        )
    }
    result_df <- do.call(rbind, apply(combinations, 1, function(row) {
        process_combination(row["i"], row["j"], vec_x, tau, alpha, delta,
                            treatment_group)
    }))
    beta_vec <- result_df$beta
    density_vec <- result_df$density
    cluster_vec <- result_df$cluster
    sample_vec <- result_df$sample

    df_new_tmp <- data.frame(beta_vec = beta_vec, density_vec = density_vec,
                             cluster_vec= cluster_vec,sample_vec = sample_vec)
    df_new_tmp$cluster_vec <-factor(df_new_tmp$cluster_vec, levels= auc$State)
    df_new_tmp$Cluster_full <- as.factor(df_new_tmp$cluster_vec)
    levels(df_new_tmp$Cluster_full) <- auc$label
    color_length_fd <- R
    colours_fd <- (seq_gradient_pal(low = "#FFC20A", high = "#0C7BDC",
                                 space = "Lab"))(seq(1, color_length_fd)/
                                                     color_length_fd)
    cluster_size <- table(hidden_states)
    plot_graph <- ggplot(df_new_tmp, aes(x = beta_vec, y = density_vec,
                                         color = sample_vec)) + geom_line() +
        scale_color_manual(values = colours_fd) +
        facet_wrap(~factor(Cluster_full, levels = auc$label),
                   scales = "free_y") + labs(color = "Treatment Groups",
                                             x = "Beta value",
                                             y = "Density")+ggtitle(title_text)
    y <- vapply(auc$State, function(i) {
        max_value <- max(df_new_tmp[df_new_tmp$cluster_vec == i, 2])
        return(max_value)
    }, numeric(1))
    f_labels <- data.frame(Cluster_full = levels(df_new_tmp$Cluster_full),
                           label=as.vector(round((cluster_size[auc$State]/C),
                                                 3)), x = 0.92, y = y)
    plot_graph <- plot_graph + geom_text(data = f_labels, aes(x = x, y = y,
                                                              label = label,
                                                              color = NA),
                                         show.legend = FALSE,fontface="bold")
    return(plot_graph)
}

uncertainty_plots <- function(data_comp, z, hidden_states, C,
                              uncertainty_threshold, title_text) {
    labels <- c(max_uc = "Maximum uncertainty")
    z_chr <- z[rownames(z) %in% data_comp$IlmnID,, drop=FALSE ]
    classification_final <- apply(z_chr, 1, max)
    uncertainty <- 1 - classification_final
    tau <- (table(hidden_states))/C
    unc_df <- cbind(uncertainty, hidden_states)
    unc_df <- as.data.frame(unc_df)
    colnames(unc_df) <- c("Uncertainty", "Cluster")
    unc_df$Cluster <- as.factor(unc_df$Cluster)
    unc_df_sorted <- unc_df[order(unc_df$Cluster), , drop=FALSE]
    max_unc <- uncertainty_threshold
    h <- max_unc + 0.015
    max_uncertainty <- data.frame(yintercept = h, max_uncertainty = factor(h))
    plot_graph <- ggplot(unc_df_sorted, aes(x = Cluster, y = Uncertainty)) +
        geom_boxplot() + xlab("Hidden States") +
        ggtitle(title_text) + coord_cartesian(ylim = c(0, 1)) +
        geom_hline(aes(yintercept = max_unc,
                       linetype = paste("Uncertainty threshold = ",
                                        max_unc)), color = "black") +
        scale_linetype_manual(name = "", values = 2,
                              guide = guide_legend(override.aes =
                                                       list(color = "black")))
    return(plot_graph)
}

se<-function(SummarizedExperiment)
{
    SummarizedExperiment <- SummarizedExperiment
    if (!is(SummarizedExperiment, "RangedSummarizedExperiment")) {
        stop("'SummarizedExperiment' must be a
             RangedSummarizedExperiment object")
    }
    return(SummarizedExperiment)
}
anno_data<-function(annotatedData)
{
    if(is.null(annotatedData))
        annotatedData <- DataFrame(matrix(0, nrow=0,ncol=0))
    return(annotatedData)
}

beta_value_numeric<-function(data,anno_file)
{
    final_subset <- subset(data, select = -IlmnID)
    row <- nrow(final_subset)
    col <- ncol(final_subset)
    numeric_vec <- as.numeric(as.matrix(final_subset))
    final_subset <- matrix(numeric_vec, ncol = col)
    if (abs(max(final_subset) - 1) < 1e-06) {
        max_f <- max(final_subset[final_subset != max(final_subset)])
    } else { max_f <- max(final_subset) }
    if (abs(min(final_subset) - 0) < 1e-06) {
        min_f <- min(final_subset[final_subset != min(final_subset)])
    } else { min_f <- min(final_subset)}
    final_subset[final_subset > max_f] <- max_f
    final_subset[final_subset < min_f] <- min_f
    cols <- which(colnames(data) != "IlmnID")
    data[, cols] <- final_subset
    data <- as.data.frame(data)
    data2<-merge(data,anno_file[,c("IlmnID","CHR","MAPINFO"), drop=FALSE],
                by="IlmnID")
    col_order <- which(colnames(data2) == "IlmnID" | colnames(data2) == "CHR"|
                           colnames(data2) == "MAPINFO")
    col_order2 <- which(colnames(data2) != "IlmnID" & colnames(data2)!="CHR" &
                            colnames(data2) != "MAPINFO")
    data3 <- data2[, c(col_order, col_order2), drop=FALSE]
    return(data3)
}

##-----------------------------------------------------------------------------
context("betaHMM function tests")

set.seed(12345)
obj <- matrix(round(runif(50, 1, 100)), ncol=8, nrow=10)
obj<-as.data.frame(obj)
x=seq(1,10)
IlmnID<-paste("cg",x,sep = "")
obj1<-data.frame(IlmnID=IlmnID,obj)
obj2<-data.frame(IlmnID=IlmnID,CHR=1,MAPINFO=x)

test_that("M, N and R are scalar positive integers", {
  expect_error(betaHMM(obj1, obj2, M=-3,N =-3,R=-3))
  expect_error(betaHMM(obj1, obj2, M=matrix(rnorm(6), nrow=3),
                       N=matrix(rnorm(6), nrow=3),R=matrix(rnorm(6), nrow=3)))
  expect_error(betaHMM(obj1, obj2, M=c(-3, -2, -1, 0, 1, 2, 3),
                       N=c(-3, -2, -1, 0, 1, 2, 3),
                       R=c(-3, -2, -1, 0, 1, 2, 3)))
  expect_error(betaHMM(obj1, obj2, M=c(0, 1, 2, 3),
                       N=c(0, 1, 2, 3),R=c(0, 1, 2, 3)))
  expect_error(betaHMM(obj1, obj2, M=c(1.5, 3.3, 5.2),  N=c(1.5, 3.3, 5.2),
                       R=c(1.5, 3.3, 5.2)))
})

test_that("methylation and annotation data are in dataframe/matrix/
          RangedSummarizedExperiment/ GRanges object", {
    expect_error(betaHMM(methylation_data=list(a=1,b=2),
                         annotation_file=list(a=1,b=2),
                         M=3,N =4,R=2))
      expect_error(betaHMM(methylation_data=seq(1,10),
                           annotation_file=seq(1,10),
                           M=3,N =4,R=2))
      expect_error(betaHMM(methylation_data=rep("a",10),
                           annotation_file=rep("a",10),
                           M=3,N =4,R=2))
})

test_that("treatment_group is a vector of string values",{
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         treatment_group=c(1,1)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         treatment_group=1))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         treatment_group=matrix(rnorm(10),ncol=5)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         treatment_group=list(s=1,j=2)))
})

test_that("parallel_process takes a TRUE/FALSE value",{
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         parallel_process=c(1,2)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         parallel_process=1))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         parallel_process=list(a=1,b=1)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         parallel_process=matrix(rnorm(6),ncol=2)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         parallel_process="abc"))
})


test_that("seed takes a numerical scalar value",{
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         seed="abc"))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         seed=c(1,10)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         seed=list(a=1,b=1)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         seed=matrix(rnorm(6),ncol=2)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         seed=TRUE))
})

test_that("iterations takes a numerical scalar value",{
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         iterations="abc"))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         iterations=c(1,10)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         iterations=list(a=1,b=1)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         iterations=matrix(rnorm(6),ncol=2)))
    expect_error(betaHMM(obj1,obj2,M=3,N=4,R=2,
                         iterations=TRUE))
})

test_that("M, N and R are scalar positive integers", {
    expect_error(betaHMMrun(obj1, obj2, M=-3,N =-3,R=-3,
                 treatment_group = NULL, parallel_process = FALSE,
                 seed = NULL,iterations=100))
    expect_error(betaHMMrun(obj1, obj2, M=matrix(rnorm(6), nrow=3),
                         N=matrix(rnorm(6), nrow=3),R=matrix(rnorm(6), nrow=3),
                         treatment_group = NULL, parallel_process = FALSE,
                         seed = NULL,iterations=100))
    expect_error(betaHMMrun(obj1, obj2, M=c(-3, -2, -1, 0, 1, 2, 3),
                         N=c(-3, -2, -1, 0, 1, 2, 3),
                         R=c(-3, -2, -1, 0, 1, 2, 3),
                         treatment_group = NULL, parallel_process = FALSE,
                         seed = NULL,iterations=100))
    expect_error(betaHMMrun(obj1, obj2, M=c(0, 1, 2, 3),
                         N=c(0, 1, 2, 3),R=c(0, 1, 2, 3),
                         treatment_group = NULL, parallel_process = FALSE,
                         seed = NULL,iterations=100))
    expect_error(betaHMMrun(obj1, obj2, M=c(1.5, 3.3, 5.2),N=c(1.5, 3.3, 5.2),
                         R=c(1.5, 3.3, 5.2),
                         treatment_group = NULL, parallel_process = FALSE,
                         seed = NULL,iterations=100))
})

obj<-new("betaHMMResults")
test_that("AUC_threshold and uncertainty are scalar positive floating point
          number and within 0 and 1", {
    expect_error(dmc_identification(obj, AUC_threshold = 1.2,
                                    uncertainty=0.8))
              expect_error(dmc_identification(obj, AUC_threshold = 0.2,
                                              uncertainty=1.6)
                           )
              expect_error(dmc_identification(obj, AUC_threshold = -0.2,
                                              uncertainty=-0.8))

})

test_that("AUC_threshold and uncertainty are scalar positive floating point
          number and within 0 and 1", {
              expect_error(dmc_identification_run(obj, AUC_threshold = 1.2,
                                              uncertainty=0.8))
              expect_error(dmc_identification_run(obj, AUC_threshold = 0.2,
                                              uncertainty=1.6)
              )
              expect_error(dmc_identification_run(obj, AUC_threshold = -0.2,
                                              uncertainty=-0.8))

          })

obj3<-new("dmcResults")
test_that("DMC_count is a scalar positive integer greater than 1.", {
              expect_error(dmr_identification(obj3, DMC_count = 0))
              expect_error(dmr_identification(obj3, DMC_count=0.2)
              )
              expect_error(dmr_identification(obj3, DMC_count=-2))
              expect_error(dmr_identification(obj3, DMC_count=1))
          })

obj6<-matrix(rnorm(100),ncol=10)
test_that("DMC_count is a scalar positive integer greater than 1.", {
    expect_error(dmr_identification_run(obj6, DMC_count = 0))
    expect_error(dmr_identification_run(obj6, DMC_count=0.2)
    )
    expect_error(dmr_identification_run(obj6, DMC_count=-2))
    expect_error(dmr_identification_run(obj6, DMC_count=1))
})


test_that("M and N are scalar positive integers", {
    expect_error(threshold_identification(obj1[,1:5], M=-3,N =-3))
    expect_error(threshold_identification(obj1[,1:5],M=matrix(rnorm(6),nrow=3),
                         N=matrix(rnorm(6), nrow=3)))
    expect_error(threshold_identification(obj1[,1:5], M=c(-3, -2,-1, 0, 1,2,3),
                         N=c(-3, -2, -1, 0, 1, 2, 3)))
    expect_error(threshold_identification(obj1[,1:5], M=c(0, 1, 2, 3),
                         N=c(0, 1, 2, 3)))
    expect_error(threshold_identification(obj1[,1:5], M=c(1.5, 3.3, 5.2),
                                          N=c(1.5, 3.3, 5.2)))
})

test_that("parameter_estimation_only has a TRUE/FALSE input",
          {
          expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                parameter_estimation_only=
                                                    "abc"))
          expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                parameter_estimation_only=
                                                    10))
          expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                parameter_estimation_only=
                                                    c(10,10)))
          })

test_that("package_workflow has a TRUE/FALSE input",
          {
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    package_workflow = "abc"))
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    package_workflow = 10))
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    package_workflow =
                                                        c(10,10)))
          })

test_that("seed has a positive scalar input",
          {
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    seed  = "abc"))
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    seed = -10))
              expect_error(threshold_identification(obj1[,1:5], M=3,N =4,
                                                    seed = c(10,10)))
          })



test_that("Uncertainty is a positive floating point number lying between
          0 and 1",{
    expect_error(plot(obj,chromosome="1",what="fitted density",
                      uncertainty_threshold=-2))
    expect_error(plot(obj,chromosome="1",what="fitted density",
                      uncertainty_threshold=2))
    expect_error(plot(obj,chromosome="1",what="fitted density",
                      uncertainty_threshold=c(-3,-2)))
    expect_error(plot(obj,chromosome="1",what="fitted density",
                      uncertainty_threshold=c(1.5,2)))
    expect_error(plot(obj,chromosome="1",what="fitted density",
                      uncertainty_threshold=matrix(rnorm(6),nrow=3)))

})
test_that("what is a scalar string.",
          {expect_error(plot(obj,chromosome="1",what=1))
              expect_error(plot(obj,chromosome="1",what=c("fitted",
                                                                "kernel")))
              expect_error(plot(obj,chromosome="1",what=matrix(rnorm(6),
                                                                     nrow=3)))
          })

test_that("start_CpG is scalar and of type character",{
              expect_error(plot(obj3,start_CpG=c("cg1","cg2"),
                                end_CpG=2))
              expect_error(plot(obj3,start_CpG=NULL,
                                end_CpG=2))
              expect_error(plot(obj3,start_CpG=TRUE,
                                end_CpG=2))
              expect_error(plot(obj3,start_CpG=1,
                                end_CpG=2))

          })

test_that("end_CpG is either scalar numeric or scalar and character type",{
              expect_error(plot(obj3,start_CpG="cg1",
                                end_CpG=TRUE))
              expect_error(plot(obj3,start_CpG="cg1",
                                end_CpG=c(1,10)))
              expect_error(plot(obj3,start_CpG="cg1",
                                end_CpG=NULL))
              expect_error(plot(obj3,start_CpG="cg1",
                                end_CpG=matrix(rnorm(6),nrow=2)))

          })

test_that("Extra input parameters are not passed when plotting DMR
          detection plot",{
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=2,what="fitted density"))
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=2,plot_threshold=TRUE))

})

test_that("Title is a string",{
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=2,title=1))
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=2,title=TRUE))

})

test_that("dmcResults object passed when accessing plotDMR function",{
              expect_error(plot(obj1,start_CpG="cg1",
                                end_CpG=2))
              expect_error(plot(matrix(rnorm(6),nrow=2),start_CpG="cg1",
                                end_CpG=c2))
              expect_error(plot(c(1,1),start_CpG="cg1",
                                end_CpG=2))

          })

test_that("title is correct in plotDMR function",{
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=2,title=1))
    expect_error(plot(obj3,start_CpG="cg1",
                      end_CpG=c2,title=c(1,1)))

})
obj4<-new("threshold_Results")

test_that("plot_threshold is carrying TRUE/FALSE value.",
          {expect_error(plot(obj4,plot_threshold="ABC"))
          expect_error(plot(obj4,plot_threshold=1))
          expect_error(plot(obj4,plot_threshold=matrix(rnorm(6),nrow=3)))
          expect_error(plot(obj4,plot_threshold=c(TRUE,FALSE,TRUE)))})

test_that("For plotting threshold the correct object is passed as input",
          {expect_error(plot(obj1,plot_threshold=TRUE))
              expect_error(plot(obj3,plot_threshold=TRUE))
             })

test_that("what is a scalar string.",
          {expect_error(plot(obj4,plot_threshold=FALSE,what=1))
              expect_error(plot(obj4,plot_threshold=TRUE,what=c("fitted",
                                                                "kernel")))
              expect_error(plot(obj4,plot_threshold=TRUE,what=matrix(rnorm(6),
                                                                     nrow=3)))
              })

test_that("AUC_DM_analysis has positive values as input for M, N, R and K",
          {expect_error(AUC_DM_analysis(M=-3,N=-3, R=-3, K=-3,
                                        tau=c(0.1,0.3,0.6), A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))})

test_that("AUC_DM_analysis has positive values as input for M, N, R and K",
          {expect_error(AUC_DM_analysis(M=-3,N=-3, R=-3, K=-3,
                                        tau=c(0.1,0.3,0.6), A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))})

test_that("AUC_DM_analysis has scalar values for M",
          {expect_error(AUC_DM_analysis(M=c(1,1,1),N=c(4,4), R=2,
                                        K=9,
                                        tau=c(0.1,0.3,0.6), A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))
              expect_error(AUC_DM_analysis(M=matrix(rnorm(4),nrow=2),N=c(4,4),
                                           R=2,
                                           K=9,
                                           tau=c(0.1,0.3,0.6),
                                           A=matrix(rnorm(81),nrow=9),
                                           phi=list(sp_1=c(1,1,1),
                                                    sp_2=c(1,1,1))))})

test_that("AUC_DM_analysis has scalar values for R",
          {expect_error(AUC_DM_analysis(M=3,N=c(4,4), R=c(1,1,1),
                                        K=9,
                                        tau=c(0.1,0.3,0.6), A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))
              expect_error(AUC_DM_analysis(M=3,N=c(4,4),
                                           R=matrix(rnorm(4),nrow=2),
                                           K=9,
                                           tau=c(0.1,0.3,0.6),
                                           A=matrix(rnorm(81),nrow=9),
                                           phi=list(sp_1=c(1,1,1),
                                                    sp_2=c(1,1,1))))})
test_that("AUC_DM_analysis has scalar values for K",
          {expect_error(AUC_DM_analysis(M=3,N=c(4,4), R=2,
                                        K=c(1,1,1),
                                        tau=c(0.1,0.3,0.6), A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))
              expect_error(AUC_DM_analysis(M=3,N=c(4,4),
                                           R=2,
                                           K=matrix(rnorm(4),nrow=2),
                                           tau=c(0.1,0.3,0.6),
                                           A=matrix(rnorm(81),nrow=9),
                                           phi=list(sp_1=c(1,1,1),
                                                    sp_2=c(1,1,1))))})
test_that("AUC_DM_analysis has a vector input for tau",
          {expect_error(AUC_DM_analysis(M=3,N=c(4,4), R=2,
                                        K=9,
                                        tau=0.5, A=matrix(rnorm(81),
                                                                     nrow=9),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))
              expect_error(AUC_DM_analysis(M=3,N=c(4,4),
                                           R=2,
                                           K=9,
                                           tau=matrix(rnorm(4),nrow=2),
                                           A=matrix(rnorm(81),nrow=9),
                                           phi=list(sp_1=c(1,1,1),
                                                    sp_2=c(1,1,1))))})
test_that("AUC_DM_analysis has a matrix input for A",
          {expect_error(AUC_DM_analysis(M=3,N=c(4,4), R=2,
                                        K=9,
                                        tau=c(0.1,0.2,0.7), A=c(1,2,3),
                                        phi=list(sp_1=c(1,1,1),
                                                 sp_2=c(1,1,1))))
              expect_error(AUC_DM_analysis(M=3,N=c(4,4),
                                           R=2,
                                           K=9,
                                           tau=c(0.1,0.2,0.7),
                                           A=3,
                                           phi=list(sp_1=c(1,1,1),
                                                    sp_2=c(1,1,1))))})
test_that("AUC_DM_analysis has a list input for phi",
          {expect_error(AUC_DM_analysis(M=3,N=c(4,4), R=2,
                                        K=9,
                                        tau=c(0.1,0.2,0.7), A=matrix(rnorm(81),
                                                                     nrow = 9),
                                        phi=c(1,1)))
              expect_error(AUC_DM_analysis(M=3,N=c(4,4),
                                           R=2,
                                           K=9,
                                           tau=c(0.1,0.2,0.7),
                                           A=matrix(rnorm(81),nrow = 9),
                                           phi=3))})

test_that("backward function has a matrix input for probabilities",
          {expect_error(backward(probabilities=c(1,1,1),
                                trained_params = list(A = matrix(rnorm(81),
                                                                 nrow=9),
                                                      tau = c(0.1,0.2,0.7),
                                                      phi = list(sp_1=c(1,1,1),
                                                                 sp_2=c(1,1,1)
                                                                 ))))})
test_that("backward function has a list input for trained_params",
          {expect_error(backward(probabilities=matrix(rnorm(81),ncol=9),
                                 trained_params = c(1,1,1) ))
              expect_error(backward(probabilities=matrix(rnorm(81),ncol=9),
                                    trained_params=matrix(rnorm(81),ncol=9)))})

test_that("forward function has a matrix input for probabilities",
          {expect_error(forward(probabilities=c(1,1,1),
                                 trained_params = list(A = matrix(rnorm(81),
                                                                  nrow=9),
                                                       tau = c(0.1,0.2,0.7),
                                                       phi=list(sp_1=c(1,1,1),
                                                                sp_2=c(1,1,1)
                                                       ))))})
test_that("forward function has a list input for trained_params",
          {expect_error(forward(probabilities=matrix(rnorm(81),ncol=9),
                                 trained_params = c(1,1,1) ))
              expect_error(forward(probabilities=matrix(rnorm(81),ncol=9),
                                    trained_params=matrix(rnorm(81),ncol=9)))})

test_that("initialise_parameters has a positive scalar input for M parameter",
          {expect_error(initialise_parameters(data=obj1, M=-3, N=c(4,4), R=2,
                                              seed = NULL))
              expect_error(initialise_parameters(data=obj1, M=c(1,1), N=c(4,4),
                                                 R=2,
                                                 seed = NULL))})

test_that("initialise_parameters has a positive scalar input for R parameter",
          {expect_error(initialise_parameters(data=obj1, M=3, N=c(4,4), R=-2,
                                              seed = NULL))
              expect_error(initialise_parameters(data=obj1, M=3, N=c(4,4),
                                                 R=c(1,1),
                                                 seed = NULL))})

test_that("initialise_parameters has a positive vector input for N parameter",
          {expect_error(initialise_parameters(data=obj1, M=3, N=c(-4,-4), R=2,
                                              seed = NULL))
              expect_error(initialise_parameters(data=obj1, M=3, N=c("a","a"),
                                                 R=2,
                                                 seed = NULL))})

obj1<-as.data.frame(obj1)
test_that("initialise_parameters has a dataframe input for data parameter",
          {expect_error(initialise_parameters(data=c(1,1), M=3, N=c(4,4), R=2,
                                              seed = NULL))
              expect_error(initialise_parameters(data=1, M=3, N=c("a","a"),
                                                 R=2,
                                                 seed = NULL))
              expect_error(initialise_parameters(data=as.matrix(obj1), M=3,
                                                 N=c(4,4),
                                                 R=2,
                                                 seed = NULL))})


test_that("initialise_parameters has a positive scalar input for seeed
          parameter",
          {expect_error(initialise_parameters(data=obj1, M=3, N=c(4,4), R=2,
                                              seed = -100))
              expect_error(initialise_parameters(data=obj1, M=3, N=c("a","a"),
                                                 R=2,
                                                 seed = "abc"))
              expect_error(initialise_parameters(data=obj1, M=3, N=c("a","a"),
                                                 R=2,
                                                 seed = c(1,1)))})

test_that("Viterbi has positive scalar values for M, R and K",
          {expect_error(Viterbi(data=obj1[,-1], M=-3, N=c(4,4), R=-2,
                                tau=c(0.1,0.2,0.3),
                                A=matrix(rnorm(81),nrow=9),
                                phi=list(sp_1=c(1,1,1),
                                         sp_2=c(1,1,1)),K=-9))
              expect_error(Viterbi(data=obj1[,-1], M=c(1,1), N=c(4,4),R=c(1,1),
                                   tau=c(0.1,0.2,0.3),
                                   A=matrix(rnorm(81),nrow=9),
                                   phi=list(sp_1=c(1,1,1),
                                            sp_2=c(1,1,1)),K=c(1,1)))})

test_that("Viterbi has positive vector input for tau",
          {expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                tau=c(-3,-3),
                                A=matrix(rnorm(81),nrow=9),
                                phi=list(sp_1=c(1,1,1),
                                         sp_2=c(1,1,1)),K=9))
              expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                   tau=-3,
                                   A=matrix(rnorm(81),nrow=9),
                                   phi=list(sp_1=c(1,1,1),
                                            sp_2=c(1,1,1)),K=9))
              expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                   tau=list(),
                                   A=matrix(rnorm(81),nrow=9),
                                   phi=list(sp_1=c(1,1,1),
                                            sp_2=c(1,1,1)),K=9))})

test_that("The phi has a list input for Viterbi function",
          {expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                tau=c(0.1,0.2,0.7),
                                A=matrix(rnorm(81),nrow=9),
                                phi=c(1,1),K=9))
              expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                   tau=c(0.1,0.2,0.7),
                                   A=matrix(rnorm(81),nrow=9),
                                   phi=1,K=9))
              expect_error(Viterbi(data=obj1[,-1], M=3, N=c(4,4), R=2,
                                   tau=c(0.1,0.2,0.7),
                                   A=matrix(rnorm(81),nrow=9),
                                   phi=matrix(rnorm(6),ncol=2),K=9))})

test_that("BaumWelch function has positive scalar values for M,K and R",
          {expect_error(BaumWelch(data=obj, trained_params=NULL,K=-3,
                                  M=-3, N=c(4,4), R=-3,
            seed = NULL,iterations= 100))
              expect_error(BaumWelch(data=obj, trained_params=NULL,K=c(1,1),
                                     M=c(1,1), N=c(4,4), R=c(1,1),
                                     seed = NULL,iterations= 100))
          })

test_that("BaumWelch function has positive scalar or vector
          integer input for N",
          {expect_error(BaumWelch(data=obj, trained_params=NULL,K=9,
                                  M=3, N=c("a","b"), R=2,
                                  seed = NULL,iterations= 100))
              expect_error(BaumWelch(data=obj, trained_params=NULL,K=9,
                                     M=3, N=c(0.4,0.2), R=2,
                                     seed = NULL,iterations= 100))
              expect_error((BaumWelch(data=obj, trained_params=NULL,K=9,
                                      M=3, N=0.2, R=2,
                                      seed = NULL,iterations= 100)))
              expect_error((BaumWelch(data=obj, trained_params=NULL,K=9,
                                      M=3,
                                      N=matrix(rnorm(6),ncol=2), R=2,
                                      seed = NULL,iterations= 100)))
              expect_error((BaumWelch(data=obj, trained_params=NULL,K=9,
                                      M=3, N=list(a=1,b=1), R=2,
                                      seed = NULL,iterations= 100)))
          })

test_that("BaumWelch function has a dataframe as input for data variable",
          {expect_error(BaumWelch(data=3, trained_params=NULL,K=9,
                                  M=3, N=c(4,4), R=2,
                                  seed = NULL,iterations= 100))
              expect_error(BaumWelch(data=c(1,1), trained_params=NULL,K=9,
                                     M=3, N=c(4,4), R=2,
                                     seed = NULL,iterations= 100))
          })
test_that("BaumWelch function has a scalar positive value as input for seed
            and iterations",
          {expect_error(BaumWelch(data=obj, trained_params=NULL,K=9,
                                  M=3, N=c(4,4), R=2,
                                  seed = c(1,1) ,iterations= c(1,1)))
              expect_error(BaumWelch(data=obj, trained_params=NULL,K=9,
                                     M=3, N=c(4,4), R=2,
                                     seed = -3,iterations= -3))
          })

test_that("initialise_parameters_th has a positive scalar input for
          M parameter",
          {expect_error(initialise_parameters_th(data=obj1, M=-3, N=c(4,4),
                                                 R=2,
                                              seed = NULL))
              expect_error(initialise_parameters_th(data=obj1, M=c(1,1),
                                                    N=c(4,4),
                                                 R=2,
                                                 seed = NULL))})

test_that("initialise_parameters_th has a positive scalar input for
          R parameter",
          {expect_error(initialise_parameters_th(data=obj1, M=3, N=c(4,4),
                                                 R=-2,
                                              seed = NULL))
              expect_error(initialise_parameters_th(data=obj1, M=3, N=c(4,4),
                                                 R=c(1,1),
                                                 seed = NULL))})

test_that("initialise_parameters_th has a positive vector input for
          N parameter",
          {expect_error(initialise_parameters_th(data=obj1, M=3, N=c(-4,-4),
                                                 R=2,
                                              seed = NULL))
              expect_error(initialise_parameters_th(data=obj1, M=3,
                                                    N=c("a","a"),
                                                 R=2,
                                                 seed = NULL))})

test_that("initialise_parameters_th has a positive scalar input for seeed
          parameter",
          {expect_error(initialise_parameters_th(data=obj1, M=3, N=c(4,4),
                                                 R=2,
                                              seed = -100))
              expect_error(initialise_parameters_th(data=obj1, M=3,
                                                    N=c("a","a"),
                                                 R=2,
                                                 seed = "abc"))
              expect_error(initialise_parameters_th(data=obj1, M=3,
                                                    N=c("a","a"),
                                                 R=2,
                                                 seed = c(1,1)))})


test_that("threshold function has a numerical vector input for tau",
          {expect_error(threshold_values(data=obj1,tau=1,
                                         phi=list(sp_1=c(1,1,1),sp_2=c(1,1,1)
                                                  )))
              expect_error(threshold_values(data=obj1,
                                            tau=matrix(rnorm(6),ncol=2),
                                            phi=list(sp_1=c(1,1,1),
                                                     sp_2=c(1,1,1)
                                            )))
              expect_error(threshold_values(data=obj1,
                                            tau=list(tau1=0.5,tau2=0.5),
                                            phi=list(sp_1=c(1,1,1),
                                                     sp_2=c(1,1,1)
                                            )))
              expect_error(threshold_values(data=obj1,
                                            tau=c("a","b"),
                                            phi=list(sp_1=c(1,1,1),
                                                     sp_2=c(1,1,1)
                                            )))
              })

test_that("threshold function has a list input for phi",
          {expect_error(threshold_values(data=obj1,tau=c(0.1,0.2,0.7),
                                         phi=1
                                         ))
              expect_error(threshold_values(data=obj1,tau=c(0.1,0.2,0.7),
                                            phi=c(1,2)
              ))
              expect_error(threshold_values(data=obj1,tau=c(0.1,0.2,0.7),
                                            phi=matrix(rnorm(6),ncol=2)
              ))
              expect_error(threshold_values(data=obj1,tau=c(0.1,0.2,0.7),
                                            phi=as.data.frame(
                                                matrix(rnorm(6),ncol=2))
              ))
          })



test_that("kernel density plot has correct input",{
    expect_error(kernel_density_plot(data=obj1, hidden_states=1,
                        auc=matrix(rnorm(6),ncol=3), C=c(1,10),
                         treatment_group=c("B","T"), title_text=NULL))
    expect_error(kernel_density_plot(data=obj1,
                                     hidden_states=matrix(rnorm(6),ncol=2),
                                     auc=matrix(rnorm(6),ncol=3), C=c(1,10),
                                     treatment_group=c("B","T"),
                                     title_text=NULL))
    expect_error(kernel_density_plot(data=obj1,
                                     hidden_states=list(a="1",b="2"),
                                     auc=matrix(rnorm(6),ncol=3), C=c(1,10),
                                     treatment_group=c("B","T"),
                                     title_text=NULL))
})

test_that("fitted density plot has correct input",{
    expect_error(fitted_density_plot(phi=c(1,10), hidden_states=1,
                                     auc=matrix(rnorm(6),ncol=3),R=c(2,2),
                                     K=c(2,2), C=c(1,10),
                                     treatment_group=c("B","T"),
                                     title_text=NULL))
    expect_error(fitted_density_plot(phi=1,
                                     hidden_states=matrix(rnorm(6),ncol=2),
                                     auc=matrix(rnorm(6),ncol=3),R=c(2,2),
                                     K=c(2,2), C=c(1,10),
                                     treatment_group=c("B","T"),
                                     title_text=NULL))
    expect_error(fitted_density_plot(phi=matrix(rnorm(6),ncol=2),
                                     hidden_states=1,
                                     auc=matrix(rnorm(6),ncol=3),
                                     R=matrix(rnorm(6),ncol=2),
                                     K=matrix(rnorm(6),ncol=2),
                                     C=matrix(rnorm(6),ncol=2),
                                     treatment_group=c("B","T"),
                                     title_text=NULL))
})


test_that("Uncertainty plot has correct form of input",{
    expect_error(uncertainty_plots(data_comp=obj2,
                                   z=seq(1,10), hidden_states=c(1,10),C=c(1,2),
                                   uncertainty_threshold=
                                       matrix(rnorm(6),ncol=2),
                                   title_text=NULL))
})

test_that("individual function for data processing has correct input",{
    expect_error(beta_value_numeric(data=1,anno_file=1))
    expect_error(beta_value_numeric(data=list(a=1,b=1),
                                    anno_file = list(a=1,b=1)))
})

#' @title Simulated DNA methylation data
#'
#' @description A subset of the dataset containing beta methylation values from
#' \eqn{R=2} sample types (Benign and Tumour), collected from \eqn{N=4}
#' patients from the a prostate cancer study. The dataset contains methylation
#' values corresponding to chromosome 7.
#'
#' @details The array data were then normalized and and probes located outside
#' of CpG sites and on the sex chromosome were filtered out. The CpG sites with
#' missing values were removed from the resulting dataset. A subset of the
#' complete dataset has been uploaded in the package for testing purposes.
#' The complete dataset is available on
#' \href{https://github.com/koyelucd/betaclust}{GitHub}.
#' @seealso \code{\link{annotation_data}}
#' @format A data frame with 38672 rows and 9 columns. The data contain no
#' missing values.
#' \itemize{
#' \item{IlmnID: The unique identifier from the Illumina CG database,
#' i.e. the probe ID.}
#' \item{Benign_Patient_1: Methylation values from benign tissue from
#' patient 1.}
#' \item{Benign_Patient_2: Methylation values from benign tissue from
#' patient 2.}
#' \item{Benign_Patient_3: Methylation values from benign tissue from
#' patient 3.}
#' \item{Benign_Patient_4: Methylation values from benign tissue from
#' patient 4.}
#' \item{Tumour_Patient_1: Methylation values from tumor tissue from
#' patient 1.}
#' \item{Tumour_Patient_2: Methylation values from tumor tissue from
#'  patient 2.}
#'  \item{Tumour_Patient_3: Methylation values from tumor tissue from
#'  patient 3.}
#'  \item{Tumour_Patient_4: Methylation values from tumor tissue from
#'  patient 4.}}
#' @usage data(pca_methylation_data)
#' @return A data frame containing a subset of methylation data
#' from real study.
"pca_methylation_data"

#' @title Threshold indentification function
#' @description HMM for beta valued DNA data for a single treatment condition
#'
#' @export
#' @param data Methylation data and IlmnID. Maybe provided as
#' a matrix or dataframe.
#' @param package_workflow Flag set to TRUE if method called from package
#' workflow.
#' If set to FALSE then the parameter annotation_file needs to be supplied to
#' the function.
#' @param annotation_file A dataframe containing the EPIC methylation
#' annotation file.
#' @param M Number of methylation states to be identified in a
#' single DNA sample.
#' @param N Number of DNA samples (patients/replicates) collected for each
#' treatment group.
#' @param parameter_estimation_only If only model parameters are to be
#' estimated then value is TRUE else FALSE.
#' @param seed Seed to allow for reproducibility (default = NULL).
#' @param ... Extra parameters.
#' @return  An S4 object of class \code{threshold_Results}, where conditional
#' probabilities
#' of each CpG site belonging to a one of the \eqn{M} methylation states
#' is stored as a SimpleList of
#' assay data, and the corresponding estimated model parameters, the thresholds
#' and most probable hidden state sequence for each chromosome are
#' stored as metadata.
#'
#' @importFrom stats kmeans
#' @importFrom stats sd complete.cases
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @examples
#' ## Use simulated data for the betaHMM workflow example
#' set.seed(12345)
#' library(betaHMM)
#'
#' ## read files
#' data(sample_methylation_file)
#' head(sample_methylation_file)
#' data(sample_annotation_file)
#' head(sample_annotation_file)
#' ##merge data
#' df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
#' sample_methylation_file,by='IlmnID')
#'
#' ## sort data
#' df=df[order(df$CHR,df$MAPINFO),]
#' thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
#' parameter_estimation_only=TRUE,seed=12345)
#'



threshold_identification_run<-function(data,package_workflow=TRUE,
                                       annotation_file=NULL,M,N,
                                       parameter_estimation_only=FALSE,
                                       seed = NULL,...)
{
    if (M != 3) {
        stop("M cannot be more or less than 3 as this function tries to
             identify the threshold between the 3 methylation states. ")
    } else if (any(N < 1)) { stop("N cannot be
    less than 1 as one or more DNA replicates need to be analysed.")
    } else if (M!=round(M)|N!=round(N)){
        stop("M and N has to be whole numbers.")}
    if (package_workflow == FALSE) {if (is.null(annotation_file))
        stop("Annotation file cannot be empty if data is not sorted.")
        data_merged<-beta_value_numeric(data,annotation_file)
        complete_data<-as.data.frame(data_merged)
        complete_data<-complete_data[complete.cases(complete_data),,drop=FALSE]
        sorted_data<-complete_data[order(as.numeric(complete_data$CHR),
                                         as.numeric(complete_data$MAPINFO)), ]
        sorted_data <- as.data.frame(sorted_data)
        data_final <- subset(sorted_data, select = -c(CHR, MAPINFO, IlmnID))
        data_return <- subset(sorted_data, select = -c(CHR, MAPINFO))
    } else {data_final<-subset(data,select=-c(IlmnID))
    data_return<-data}
    th_bw_out <- BaumWelch(data_final, K=M,M = M, N = N, R = 1, seed = seed)
    if (parameter_estimation_only == FALSE) {
        th_vit_out<-Viterbi(data_final,M=M,N=N,R=1,th_bw_out$tau,
                               th_bw_out$A, th_bw_out$phi,K=M)
        tau <- as.numeric(table(th_vit_out)/(nrow(data_final)))
        threshold_bhmm <- threshold_values(data_final, tau, th_bw_out$phi)
    } else {th_vit_out <- NA
    threshold_bhmm <- NA }
    z <- as.data.frame(th_bw_out$z)
    rownames(z) <- data_return[, "IlmnID"]
    data_return <- as(data_return, "DataFrame")
    select.results <- SummarizedExperiment(assays = z, metadata =
                                               list(model_parameters=th_bw_out,
                                                    K=M,
                                                    hidden_states=th_vit_out,
                                                    threshold=threshold_bhmm))
    RES <- threshold_Results(as(select.results, "RangedSummarizedExperiment"),
                             annotatedData = data_return)
    return(RES)}

## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

#' Summarize results from the three betaHMM workflow functions
#'
#' A function to summarize the \code{betaHMMResults}, \code{dmcResults} or
#' \code{dmrResults} objects.
#'
#' @rdname summary
#' @aliases
#' summary
#' summary-methods
#' summary,betaHMMResults-method
#' summary,dmcResults-method
#' summary,dmrResults-method
#'
#' @param object An object of class \code{'betaHMMResults'} or
#' \code{'dmcResults'} or \code{'dmrResults'}.
#' @param ... Additional arguments
#' @author Koyel majumdar
#' @seealso \code{\link{betaHMM}}, \code{\link{dmc_identification}},
#' \code{\link{dmr_identification}}
#' @example inst/examples/betaHMM_package.R
#' @return Summary of the \code{'betaHMMResults'} or
#' \code{'dmcResults'} or \code{'dmrResults'} object.
#' @keywords methods
#' @export
#' @importFrom utils tail
setMethod(f = "summary", signature(object = "betaHMMResults"),
          function(object, ...) {
              chr_unique <- chromosome_number(object)
              anno <- annotatedData(object)
              llk_ch <- vector()
              prop_hs <- vector()
              chr_text <- vector()
              llk_ch <- vapply(chr_unique,
                               function(chr)
                                   tail(llk(object)[[paste("chr", chr,
                                                           sep = " ")]],
                                        1),numeric(1))
              chr_text <- paste("chr", chr_unique, sep = " ")
              prop_hs <- vapply(chr_unique, function(chr) {
                  states <- hidden_states(object)[[paste("chr",chr,sep = " ")]]
                  prop <- paste(round((table(states) / length(states)), 3),
                                collapse = ",")
              },character(1))

              patients <- paste(N(object), collapse = ",")
              cat("*************************************************\n")
              cat("betaHMM workflow function: Parameter estimation")
              cat("\n")
              cat(paste0("Number of hidden states estimated:", K(object)))
              cat("\n")
              cat(paste0("No. of total CpG sites:", nrow(anno)))
              cat("\n")
              cat(paste0("Number of treatment conditions :", R(object)))
              cat("\n")
              cat(paste0("No. of patients in each treatment group:", patients))
              cat("\n")
              cat("*************************************************\n")
              cat("\n")
              cat("Summary of each chromosome analysed\n")
              cat("\n")
              tab2 <- data.frame(`Chromosome Number` = chr_unique,
                                 `log-likelihood` =llk_ch,
                                 `Prop. of CpG sites in each hidden state` =
                                     prop_hs,
                                 row.names = rep("",length(chr_unique)),
                                 check.names = FALSE)
              tab2 <- as.matrix(tab2)
              print(tab2)
          })

##############################################################
#' @export
#' @rdname summary
setMethod(f = "summary", signature(object = "dmcResults"),
          function(object, ...) {
              dmc_df <- assay(object)
              chr_unique <- unique(dmc_df$CHR)
              no_of_dmc <- vector()
              cpg_site <- vector()
              calculate_values <- function(chr) {
                  df <- dmc_df[dmc_df$CHR == chr, ]
                  no_dmc <- length(which(df$DMC == 1))
                  cpg <- nrow(df)
                  list(no_dmc = no_dmc, cpg = cpg)
              }
              results <- lapply(chr_unique, calculate_values)
              no_of_dmc <-vapply(results, function(res) res$no_dmc, numeric(1))
              cpg_site <- vapply(results, function(res) res$cpg,numeric(1))

              patients <- paste(N(object), collapse = ",")
              cat("*************************************************\n")
              cat("betaHMM workflow function: DMC identification")
              cat("\n")
              cat(paste0("No. of total CpG sites:", nrow(dmc_df)))
              cat("\n")
              cat(paste0("Number of treatment conditions :", R(object)))
              cat("\n")
              cat(paste0("No. of patients in each treatment group:", patients))
              cat("\n")
              cat(paste0("Total number of DMCs:", table(dmc_df$DMC)[2]))
              cat("\n")
              cat("*************************************************\n")
              cat("\n")
              cat("\nNo. of CpG sites and DMCs in each chromosome:\n")
              tab2 <- data.frame(`Chromosome Number` = chr_unique,
                                 `No. of CpG sites` = cpg_site,
                                 `No. of DMCs` = no_of_dmc,
                                 row.names = rep("", length(chr_unique)),
                                 check.names = FALSE)
              tab2 <- as.matrix(tab2)
              print(tab2)
          })
##############################################################
#' @export
#' @rdname summary
setMethod(f = "summary", signature(object = "dmrResults"),
          function(object, ...) {
              dmr_df <- assay(object)
              chr_unique <- chromosome_number(object)
              no_of_dmr <- vector()
              avg_length <- vector()
              calculate_values <- function(chr) {
                  df <- dmr_df[dmr_df$CHR == chr, ]
                  no_dmr <- nrow(df)
                  avg_len <- round(mean(df$DMR_size), 3)
                  list(no_dmr = no_dmr, avg_len = avg_len)
              }
              results <- lapply(chr_unique, calculate_values)
              no_of_dmr <-vapply(results, function(res) res$no_dmr,numeric(1))
              avg_length<-vapply(results,function(res) res$avg_len,numeric(1))

              cat("*************************************************\n")
              cat("betaHMM workflow function: DMR identification")
              cat("\n")
              cat(paste0("Total number of DMRs:", nrow(dmr_df)))
              cat("\n")
              cat("*************************************************\n")
              cat("\n")
              cat("\n")
              cat("\nSummary of DMRs identified in each chromosome:\n")
              tab2 <- data.frame(`Chromosome Number` = chr_unique,
                                 `No. of DMRs` = no_of_dmr,
                                 `Average length of DMRs` = avg_length,
                                 row.names = rep("",length(chr_unique)),
                                 check.names = FALSE)
              tab2 <- as.matrix(tab2)
              print(tab2)
          })

#' MethylationEPIC manifest data.
#'
#' A dataset containing a subset of the manifest data from the Illumina
#' MethylationEPIC beadchip array. A subset of the complete dataset has been
#' uploaded in the package for testing purpose. The complete dataset is
#' available on \href{https://github.com/koyelucd/betaclust}{GitHub}.
#'
#' @seealso \code{\link{pca_methylation_data}}
#' @format A data frame with 100 rows and 9 columns.
#' \itemize{
#'         \item{IlmnID: The unique identifier from the Illumina CG database,
#'         i.e. the probe ID.}
#'         \item{Genome_Build: The genome build referenced by the Infinium
#'         MethylationEPIC manifest.}
#'         \item{CHR: The chromosome containing the CpG (Genome_Build = 37).}
#'         \item{MAPINFO: The chromosomal coordinates of the CpG sites.}
#'         \item{UCSC_RefGene_Name: The target gene name(s), from the UCSC
#'         database. Note: multiple listings of the same gene name indicate
#'         splice variants.}
#'         \item{UCSC_RefGene_Accession: The UCSC accession numbers of the
#'         target transcripts. Accession numbers are in the same order as the
#'         target gene transcripts.}
#'         \item{UCSC_RefGene_Group: Gene region feature category describing
#'         the CpG position, from UCSC. Features are listed in the same order
#'         as the target gene transcripts.}
#'         \item{UCSC_CpG_Islands_Name: The chromosomal coordinates of the CpG
#'         Island from UCSC.}
#'         \item{Relation_to_UCSC_CpG_Island: The location of the CpG relative
#'         to the CpG island.}
#'         }
#' @usage data(annotation_data)
#' @return A data frame containing the array design for Illumina’s
#' Human Methylation EPIC microarray for the chromosome 7. Based on the v1.0b2
#' version of the manifest file.
"annotation_data"

#' @title HMM parameter estimation using Baum-Welch algorithm
#' @description  The function determines the parameters of a homogeneous
#' beta hidden Markov model (betaHMM), wherein the Baum-Welch algorithm
#' constitutes a variant of the EM (Estimation-Maximization) procedure.
#' @keywords internal
#' @param data A dataframe of dimension \eqn{C \times (N \times R)} containing
#' methylation values for \eqn{C} CpG sites from \eqn{R}
#' treatment groups each having \eqn{N} DNA samples.
#' @param trained_params A list containing the initialized model parameters:
#' \itemize{
#' \item A - The transition matrix for the betaHMM model.
#' \item tau - The initial distribution for the betaHMM model.
#' \item phi - The shape parameters for the observation sequence data
#' in the betaHMM model.}
#' @param K The number of hidden states identified using the betaHMM model.
#' @param M Number of methylation states to be identified in a single
#' DNA sample.
#' @param N Number of DNA samples (patients/replicates) collected for each
#' treatment group.
#' @param R Number of treatment groups (For. eg: Benign and Tumour).
#' @param seed Seed to allow for reproducibility (default = NULL).
#' @param iterations Number of iterations for algorithm convergence.
#' @return A list containing:
#' \itemize{
#' \item A - The transition matrix estimated for the betaHMM model.
#' \item tau - The initial distribution estimated for the betaHMM model.
#' \item phi - The shape parameters estimated for the observed data
#' in the betaHMM model.
#' \item log_vec - A vector containing the log-likelihood values
#' calculated for each iteration of the algorithm.
#' \item z - A matrix of dimension \eqn{C \times K} containing the
#' conditional posterior probability of each CpG site belonging to each of
#' the \eqn{K} hidden states.
#' }
#' @importFrom stats dbeta
#'
#'

BaumWelch <- function(data, trained_params=NULL,K, M, N, R,
                      seed = NULL,iterations= 100){
    C <- nrow(data)
    if(K==M)
    {
        trained_params <- initialize_parameters_th(data, M, N, R, seed)
    }
    oldlogL <- 1
    BW_limit_accuracy <- 1e-5
    logL_vec <- vector()
    logL_vec <- oldlogL
    iter<-1
    while(iter<=iterations){
        iter<-iter+1
        probabilities <- list()
        n1 <- 1
        n2 <- N[1]
        for(r in seq(1,R))
        {
            if(K==M)
            {
                sp1<-trained_params$phi$sp_1
                sp2<-trained_params$phi$sp_2
            }else{
                sp1<-trained_params$phi$sp_1[r, ]
                sp2<-trained_params$phi$sp_2[r, ]
            }
            for(n in n1:n2)
            {
                probabilities[[n]] <- matrix(data[,n],ncol=K,nrow=nrow(data))
                probabilities[[n]] <- t(apply(X=probabilities[[n]],MARGIN =1,
                                              FUN = dbeta,
                                              shape1 = sp1,
                                              shape2=sp2))}
            if((r+1) <= R){
                n1 <- n1 + N[r]
                n2 <- n2 + N[r+1] } }
        prob <- matrix(probabilities[[1]], nrow = C, ncol = K)
        for(k in 2:ncol(data)){
            temp <- as.matrix(probabilities[[k]])
            prob <- prob*temp}
        probabilities<-matrix(0, ncol = K, nrow = C)
        probabilities<-prob
        forward_alpha <- forward(probabilities, trained_params)
        backward_beta <- backward(probabilities, trained_params)
        log_alpha <- forward_alpha$log_alpha
        logL_alpha_T <- forward_alpha$scaled_logL
        log_beta <- backward_beta$log_beta
        logL_beta_1 <- backward_beta$scaled_logL
        logL_alpha_t_beta_t <- 0
        middle_t <- round(C / 2)
        t <- max(log_alpha[middle_t,])
        logL_alpha_t_beta_t <- sum(exp(log_alpha[middle_t, seq_len(K)] +
                                           log_beta[middle_t, seq_len(K)]))
        logL_alpha_t_beta_t <- log(logL_alpha_t_beta_t)
        logL <- logL_alpha_t_beta_t
        if (logL == -Inf | logL == Inf | is.na(logL)){logL <- logL_alpha_T}
        if (logL == -Inf | logL == Inf | is.na(logL)) {logL <- logL_beta_1}
        eta <- matrix(c(0), ncol = K, nrow = C)
        eta<-exp(log_alpha+log_beta-logL)
        alpha_c <- log_alpha[seq(1,C-1),, drop=FALSE]
        beta_c  <- log_beta[2:C,, drop=FALSE]
        prob_log <- log(probabilities[2:C,, drop=FALSE])
        combinations <- expand.grid(i = seq(1, K), j = seq(1, K))
        xi <- apply(combinations, 1, function(comb) {
            i <- comb[["i"]]
            j <- comb[["j"]]
            exp(alpha_c[,i] + log(trained_params$A[i, j]) +
                    prob_log[, j] + beta_c[, j] - logL)
        })
        xi <- array(unlist(xi), dim = c((C-1), K, K))
        tau <- eta[1,]
        A <- matrix(0,K,K)
        A1 <- apply(xi, c(2,3), sum)
        A2 <- apply(A1, FUN = sum, MARGIN = 1)
        A <- A1/A2
        y1 <- matrix(0, nrow = R, ncol = K)
        y2 <- matrix(0, nrow = R, ncol = K)
        sh_p1 <- matrix(0, nrow = R, ncol = K)
        sh_p2 <- matrix(0, nrow = R, ncol = K)
        term <- matrix(0, nrow = R, ncol = K)
        process_r<-function(r,data,N,n1,n2){
            start<-n1[r]
            end<-n2[r]
            if(N[r] == 1)
            {
                y1 <- apply((eta*(log(data[,start:end, drop=FALSE]))),
                                 FUN=sum,MARGIN=2)/
                    (N[r]*apply(eta,FUN=sum,MARGIN=2))
                y2 <- apply((eta*(log(1-data[,start:end, drop=FALSE]))),
                                 FUN=sum,MARGIN=2)/
                    (N[r]*apply(eta,FUN=sum,MARGIN=2))
            }else{
                y1 <- apply((eta*rowSums(log(data[,start:end, drop=FALSE]))),
                                 FUN=sum,MARGIN=2)/
                    (N[r]*apply(eta,FUN=sum,MARGIN=2))
                y2 <- apply((eta*rowSums(log(1-data[,start:end, drop=FALSE]))),
                                 FUN=sum,MARGIN=2)/
                    (N[r]*apply(eta,FUN=sum,MARGIN=2))}
            term <- ((exp(-y1)-1) *(exp(-y2)-1)) - 1
            shp1 <- 0.5 + (0.5 * exp(-y2) /term)
            shp2 <- (0.5 * exp(-y2) *(exp(-y1) - 1)) /term
            return(list(shp1=shp1,shp2=shp2))

        }
        indices <- seq(1, R)
        n1<-vector()
        n2<-vector()
        n1[1]<-1
        n2[1]<-N[1]
        n1 <- c(1, cumsum(N[-R]+1))
        n2 <- cumsum(N)
        result<-lapply(indices, process_r, data = data, N = N,n1,n2)
        shp1_matrix <- matrix(NA, nrow = R, ncol = K)
        shp2_matrix <- matrix(NA, nrow = R, ncol = K)
        shp1_matrix <- do.call(rbind, lapply(result, function(res) res$shp1))
        shp2_matrix <- do.call(rbind, lapply(result, function(res) res$shp2))
        phi<-list(sp_1=shp1_matrix,sp_2=shp2_matrix)
        trained_params$A <- A
        trained_params$tau <- tau
        trained_params$phi <- phi
        logL_vec<-c(logL_vec,logL)
        diff_logL  <-  (logL - oldlogL) / oldlogL
        if (diff_logL > 0 &diff_logL < BW_limit_accuracy)
        {
            reached_limit_of_accuracy  <-  TRUE
            break}
         oldlogL <- logL
         }
    log_vec <- logL_vec[-1]
    return(list(A = A,  tau = tau, phi = phi,log_vec = log_vec, z = eta))
}

globalVariables(c("betaHMMresults", "CHR", "IlmnID", "MAPINFO", "chr",
                    "cond_prob_threshold"))
#' The betaHMM model parameter estimation function
#' @description A homogeneous hidden Markov model for the beta valued DNA
#' methylation data.
#' @details The betaHMM function employs initially set parameters (utilizing a
#' basic 3-state beta hidden Markov model) to estimate the parameters of the
#' homogeneous hidden Markov model, adapted for beta-valued DNA methylation
#' data, through implementation of the Baum-Welch algorithm. Subsequently,
#' the derived parameters are utilized to ascertain the most probable sequence
#' of hidden states using the Viterbi algorithm.
#' @export
#' @param methylation_data A dataframe of dimension \eqn{(C \times (N \times R)
#' )+1} containing methylation values for \eqn{C} CpG sites from \eqn{R}
#' treatment groups each having \eqn{N} DNA samples and the IlmnID
#' for each CpG site.
#' @param annotation_file A dataframe containing the EPIC methylation
#' annotation file.
#' @param M Number of methylation states to be identified in a
#' single DNA sample.
#' @param N Number of DNA samples (patients/replicates) collected for each
#' treatment group.
#' @param R Number of treatment groups (For. eg: Benign and Tumour).
#' @param treatment_group The names of each treatment groups/
#' conditions. If no value is passed then default values of sample names,
#' e.g. Sample 1, Sample 2, etc are used as legend text (default = NULL).
#' @param parallel_process The 'TRUE' option results in parallel processing of
#' the models for each chromosome for increased computational efficiency.
#' The default option has been set as 'FALSE' due to package testing
#' limitations.
#' @param seed Seed to allow for reproducibility (default = NULL).
#' @param iterations Number of iterations for algorithm convergence
#' (default=100).
#' @param ... Extra arguments
#' @return The function returns an object of the
#' \code{\link[betaHMM:betaHMMResults]{betaHMMResults}} class
#' which contains a SimpleList of assay data containing the posterior
#' probability of each CpG site belonging to each of the
#' \eqn{K} hidden states and the following values as metadata:
#' \itemize{
#' \item K - The number of hidden states identified using the betaHMM model.
#' \item C - The number of CpG sites analysed using the betaHMM model.
#' \item N - The number of DNA samples corresponding to each
#' treatment group analysed using the betaHMM model.
#' \item R - The number of treatment groups analysed using the betaHMM model.
#' \item A - The transition matrix estimated for the betaHMM model.
#' \item tau - The initial distribution estimated for the betaHMM model.
#' \item treatment_group - The names of the treatment
#' groups/conditions analysed.
#' \item phi - The shape parameters estimated for the observed data
#' in the betaHMM model.
#' \item llk - A vector containing the log-likelihood values calculated
#' for each iteration of the algorithm.
#' \item hidden_states - The vector containing the estimated hidden states
#' for each CpG sites. }
#' @importClassesFrom S4Vectors DataFrame
#' @importMethodsFrom S4Vectors metadata
#' @importFrom stats complete.cases
#' @importFrom foreach foreach %dopar%
#' @importFrom parallel makeCluster detectCores stopCluster
#' @importFrom doParallel registerDoParallel
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @example inst/examples/betaHMM_package.R
#'
#'
betaHMMrun <- function(methylation_data, annotation_file, M, N, R,
                       treatment_group = NULL, parallel_process = FALSE,
                       seed = NULL,iterations=100, ...) {
    if (is.null(methylation_data)) {
        stop("Please provide a dataframe containing methylation values.")
    } else if (is.null(annotation_file)) {
        stop("Please provide a dataframe containing
            annotation for EPIC array.")} else if (M > 3 | M < 2) {
                stop("M cannot be more than 3 or less than 2 as a CpG
                can be any of the 3 methylation states. ")
            } else if (R < 2) { stop("R cannot be < 2 to identify DMCs between
    2 or more conditions.") } else if (any(N < 1)) { stop("N cannot be
    less than 1 as one or more DNA replicates need to be analysed.")
    } else if (M!=round(M)|N!=round(N)|R!=round(R)){
        stop("M, N and R has to be whole numbers.")}
    if (is.null(treatment_group)) {treatment_group <-
        vapply(seq(1, R), function(x) { paste0("Sample ", x)}, character(1))
    } else if (length(treatment_group) > R) {
        stop("Treatment groups cannot be more than the number of conditions
            entered.")}
    meth_data <- methylation_data
    anno_file <- annotation_file
    meth_data <- meth_data[complete.cases(meth_data), , drop=FALSE]
    data<-beta_value_numeric(meth_data,anno_file)
    data<-as.data.frame(data)
    K <- M^R
    C <- nrow(data)
    is.scalar <- function(x) is.atomic(x) && length(x) == 1L && Im(x) == 0
    if (is.scalar(N)) {
        N <- rep(N, R)} else if (length(N) < R) {
            n <- R - length(N)
            N <- c(N, rep(N[1], n))}
    complete_data <- data
    sorted_data <- complete_data[order(as.numeric(complete_data$CHR),
                                       complete_data$MAPINFO), ]
    sorted_data <- as.data.frame(sorted_data)
    chr_unique <- unique(sorted_data$CHR)
    chr_unique <- as.character(sort(as.numeric(chr_unique)))
    ncores_bh <- ifelse(parallel_process == FALSE, 2L, detectCores())
    my.cluster_bh <- makeCluster(ncores_bh - 1)
    registerDoParallel(cl = my.cluster_bh)
    betaHMM_workflow <- function(data_chr, K, M, N, R, chr, seed = NULL,
                                 iterations=100) {
        data <- subset(data_chr, select = -c(CHR, MAPINFO, IlmnID))
        data_w_ilmnid <- subset(data_chr, select = -c(CHR, MAPINFO))
        data <- as.data.frame(data)
        data_w_ilmnid <- as.data.frame(data_w_ilmnid)
        trained_params <- initialise_parameters(data_w_ilmnid, M, N, R, seed)
        out_baumwelch<-BaumWelch(data,trained_params,K,M,N,R,seed,iterations)
        out_viterbi <- Viterbi(data, M, N, R, out_baumwelch$tau,
                               out_baumwelch$A, out_baumwelch$phi,K)
        return(list(A = out_baumwelch$A, tau = out_baumwelch$tau,
                    sp_1 = out_baumwelch$phi$sp_1,
                    sp_2 = out_baumwelch$phi$sp_2, z = out_baumwelch$z,
                    llk=out_baumwelch$log_vec,
                    hiddenStates=out_viterbi,chr=chr))}
    comb <- function(x, ...) {lapply(seq_along(x),
                                     function(i) c(x[[i]],
                                                   lapply(list(...),
                                                         function(y) y[[i]])))}
    beta_chr_out <- foreach(chr = seq(1, length(chr_unique)),
                            .combine = "comb", .multicombine = TRUE,
                            .init = list(list(), list(), list(),
                                         list(), list(), list(),
                                         list(), list())) %dopar%
        betaHMM_workflow(sorted_data[sorted_data$CHR == chr_unique[chr], ],
                         K, M, N, R, chr_unique[chr],seed,iterations)
    stopCluster(cl = my.cluster_bh)
    z_final_out <- as.data.frame(do.call(rbind, beta_chr_out[[5]]))
    chromosome_number <- unlist(beta_chr_out[[8]])
    chromosome_number_list <- paste("chr", chromosome_number)
    beta_chr_out <- lapply(seq_along(beta_chr_out), function(i) {
        names(beta_chr_out[[i]]) <- chromosome_number_list
        return(beta_chr_out[[i]])
    })
    beta_out_phi <- list()
    beta_out_phi[["sp_1"]] <- beta_chr_out[[3]]
    beta_out_phi[["sp_2"]]<-beta_chr_out[[4]]
    z<-as.data.frame(z_final_out)
    rownames(z)<-sorted_data$IlmnID
    sorted_data<-as(sorted_data,"DataFrame")
    select.results<-SummarizedExperiment(assays = z,
                                         metadata = list(K = K, N = N, R = R,
                                                         A=beta_chr_out[[1]],
                                                         tau=beta_chr_out[[2]],
                                                         phi = beta_out_phi,
                                                         treatment_group =
                                                             treatment_group,
                                                         llk=beta_chr_out[[6]],
                                                         hidden_states =
                                                             beta_chr_out[[7]],
                                                         chromosome_number =
                                                             unlist(
                                                            beta_chr_out[[8]]
                                                             )))
    RES <- betaHMMResults(as(select.results, "RangedSummarizedExperiment"),
                          annotatedData = sorted_data)
    return(RES)}

#### DMC identification
#' @title DMC identification from estimated betaHMM model parameters
#' @description The dissimilarities between the cumulative distributions
#' calculated for each hidden state are determined through employment of the
#' area-under-curve (AUC) technique. By incorporating user-defined threshold
#' values for AUC alongside the associated uncertainties in membership within
#' that hidden state, the aim is to pinpoint the most distinctively methylated
#' states. This process facilitates the identification of CpGs that exhibit the
#' most notable differential methylation, guided by the predefined threshold
#' criteria.
#' @export
#' @param betaHMM_object A \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}
#' object.
#' @param AUC_threshold The threshold for AUC metric for each chromosome.
#' @param uncertainty_threshold The threshold for uncertainty of belonging to
#' a particular hidden state, for each chromosome.
#' @param ... extra arguments
#'
#' @return The function returns an object of the
#' \code{\link[betaHMM:dmcResults]{dmcResults}} class
#' which contains a SimpleList of assay data which contains the
#' following values:
#' \itemize{
#' \item CHR Chromosome number
#' \item MAPINFO Mapinfo
#' \item IlmnID IlmnID
#' \item N*R columns containing methylation states
#' \item hidden_state The assigned hidden_state
#' \item DMC The value is 1 if the CpG is a DMC else 0.}
#' The object contains the following values as the metadata:
#' \itemize{
#' \item A list containing the AUC values for K hidden states for each
#' chromosome and the conditions compared which resulted in the highest AUC
#' value when more than 2 conditions are compared.
#' \item A list containing the conditional probability values for K hidden
#' states for each chromosome.
#' \item The treatment group labels.
#' \item K The number of hidden states estimated.
#' \item N The number of DNA replicates/patients for each treatment group.
#' \item R The number of treatment groups to be compared.
#' }
#' @importFrom stats complete.cases
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @example inst/examples/betaHMM_package.R

dmc_identification_run <- function(betaHMM_object, AUC_threshold = 0.8,
                                   uncertainty_threshold = 0.2, ...) {
    object <- betaHMM_object
    chr_unique <- chromosome_number(object)
    M <- 3
    N <- N(object)
    R <- R(object)
    K <- K(object)
    A <- A(object)
    tau <- tau(object)
    phi <- phi(object)
    z <- assay(object)
    treatment_group <- treatment_group(object)
    is.scalar <- function(x) is.atomic(x) && length(x) == 1L && Im(x) == 0
    if (is.scalar(AUC_threshold)) {
        AUC_threshold <- rep(AUC_threshold, length(chr_unique))
    } else if (length(AUC_threshold) != length(chr_unique)) {
        stop("AUC threshold cannot be a vector with length less/greater
            than the no. of chromosomes.") }
    if (is.scalar(uncertainty_threshold)) {
        uncertainty_threshold <- rep(uncertainty_threshold, length(chr_unique))
    } else if (length(uncertainty_threshold) != length(chr_unique)) {
        stop("Uncertainty threshold cannot be a vector with length less
            than the no. of chromosomes.")}
    cond_prob_threshold <- 1 - uncertainty_threshold
    df <- as.data.frame(annotatedData(object))
    col <- ncol(df)
    df_complete <- matrix(NA, nrow = 1, ncol = (col + 2))
    colnames(df_complete) <- c(colnames(df), "hidden_state", "DMC")
    auc_list <- list()
    uncertainty_list <- list()
    process_chr <- function(i) {
        phi_chr <- list()
        phi_chr[["sp_1"]] <- phi[[1]][[i]]
        phi_chr[["sp_2"]] <- phi[[2]][[i]]
        auc_df <- AUC_DM_analysis(M, N, R, K, tau[[i]], A[[i]], phi_chr)
        x <- as.data.frame(t(auc_df))
        colnames(x) <- c("State", "AUC", "DM_Conditions")
        x$AUC <- as.numeric(x$AUC)
        auc_list <- x
        x_co <- x[x$AUC >= AUC_threshold[i], , drop = FALSE]
        diff_meth_x <- x_co$State
        df_chr <- df[df$CHR == chr_unique[i], , drop = FALSE]
        if (nrow(x_co) != 0) {
            hs <- hidden_states(object)[[i]]
            df_chr$hidden_state <- hs
            z_mat <- z[row.names(z) %in% df_chr$IlmnID, , drop = FALSE]
            if (length(diff_meth_x) > 1) {
                z_sum2 <- as.vector(rowSums(z_mat[, as.numeric(diff_meth_x)]))
            } else {
                z_sum2 <- as.vector(z_mat[, as.numeric(diff_meth_x)])
            }
            df_chr$DMC <- ifelse(z_sum2 >= cond_prob_threshold[i], 1, 0)
            uncertainty_list<- 1 - z_sum2
        } else {
            df_chr$hidden_state <- 0
            df_chr$DMC <- 0
            uncertainty_list <- rep(1, nrow(df_chr))
        }
        return(list(df_chr=df_chr,auc_list=auc_list,
                    uncertainty_list=uncertainty_list))
    }
    result_list <- lapply(seq_along(chr_unique), process_chr)
    df_list <- lapply(result_list, function(res) res$df_chr)
    df_complete <- do.call(rbind, df_list)
    auc_list <- lapply(result_list, function(res) res$auc_list)
    uncertainty_list <- lapply(result_list, function(res) res$uncertainty_list)
    rownames(df_complete)<-df_complete$IlmnID
    chrom_list <- paste("chr", chr_unique)
    names(auc_list) <- chrom_list
    names(uncertainty_list) <- chrom_list
    select.results <-
        SummarizedExperiment(assays=df_complete,
                             metadata =list(K=K,N=N,R=R,
                                            treatment_group=treatment_group,
                                            AUC = auc_list,
                                            uncertainty =uncertainty_list))
    RES <- dmcResults(as(select.results, "RangedSummarizedExperiment"))
    return(RES)}

#### DMR identification
#' @title DMR identification from DMCs identified
#' @description Function to identify the DMRs from the DMCs identified in each
#' chromosome.
#' @export
#' @param dmc_identification_object a \code{dmcResults} object or
#' the assay data from the dmcResults.
#' @param DMC_count The minimal number of consecutive CpGs in a DMR.
#' @param parallel_process The 'TRUE' option results in parallel processing of
#' the DMCs from each chromosome for increased computational efficiency.
#' The default option has been set as 'FALSE' due to package testing
#' limitations.
#' @param ... extra arguments
#'
#' @return A \code{\link[betaHMM:dmrResults]{dmrResults}}
#' object containing a SimpleList of assay data containing the following data:
#' \itemize{
#' \item start_CpG - The starting CpG site IlmnID in the particular DMR
#' \item end_CpG -  The ending CpG site IlmnID in the particular DMR
#' \item DMR_size - Number of CPG sites identified in the DMR
#' \item chr_dmr - The chromosome corresponding to the CpG sites in the DMR.
#' \item map_start - MAPINFO of starting CpG site in the particular DMR
#' \item map_end -  MAPINFO of the ending CpG site in the particular DMR}
#' The object also returns the chromosomes analysed by the betaHMM model as
#' the metadata.
#' @importFrom stats complete.cases
#' @importFrom foreach foreach %dopar%
#' @importFrom parallel detectCores makeCluster stopCluster
#' @importFrom doParallel registerDoParallel
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @example inst/examples/betaHMM_package.R

dmr_identification_run <- function(dmc_identification_object, DMC_count = 2,
                                   parallel_process = FALSE, ...) {
    dmc_df <- dmc_identification_object
    chr_unique <- unique(dmc_df$CHR)
    ncores <- ifelse(parallel_process == FALSE, 2L, detectCores())
    my.cluster <- makeCluster(ncores - 1)
    registerDoParallel(cl = my.cluster)
    dmr_parallel <- function(dmc_df_chr, DMC_count) {
        block_counter<-0
        block_start <- 0
        block_end <- 0
        block_length <- 0
        C <- nrow(dmc_df_chr)
        mat <- matrix(NA, C, 3)
        for (i in seq(1, C)) { if (dmc_df_chr[i, "DMC"] == 1) {
            if (block_length == 0) {
                block_start <- i
                block_length <- 1 } else {
                    block_length <- block_length + 1}
            if (block_length >= DMC_count) {
                block_counter <- block_counter + 1 }
        } else { if (block_length >= DMC_count) {
            mat[block_counter, ] <- c(block_start, i - 1, block_length)}
            block_start <- 0
            block_length <- 0}}
        mat <- as.data.frame(mat)
        mat<-mat[complete.cases(mat),, drop=FALSE]
        df_unique<-mat
        colnames(df_unique) <- c("start_CpG", "end_CpG", "DMR_size")
        cpg_names <- as.vector(dmc_df_chr[, "IlmnID"])
        start_cpg <- vapply(df_unique$start_CpG, function(x) {
            cpg_names[x]}, character(1))
        end_cpg<-vapply(df_unique$end_CpG,
                        function(x) {cpg_names[x]},character(1))
        df_unique$start_CpG <- start_cpg
        df_unique$end_CpG <- end_cpg
        map_start <- vapply(df_unique$start_CpG, function(x) {
            dmc_df_chr[dmc_df_chr$IlmnID == x, "MAPINFO"]}, numeric(1))
        map_end <- vapply(df_unique$end_CpG, function(x) {
            dmc_df_chr[dmc_df_chr$IlmnID == x, "MAPINFO"]}, numeric(1))
        if(nrow(df_unique)!=0){
            df_unique$CHR <- unique(dmc_df_chr$CHR)
        df_unique$map_start <- map_start
        df_unique$map_end <- map_end
        df_unique$DMCs <- unlist(lapply(seq_len(nrow(df_unique)), function(j){
            start <- which(dmc_df_chr$MAPINFO == df_unique[j, 5] &
                                dmc_df_chr$CHR == df_unique[j, 4])
            end <- which(dmc_df_chr$MAPINFO == df_unique[j, 6] &
                                dmc_df_chr$CHR == df_unique[j, 4])
            x <-as.vector(unlist(dmc_df_chr[start:end,"IlmnID",drop = FALSE]))
            return(paste(as.character(x), collapse = ","))
        }))
        }
        return(df_unique)}
    dmr_mat <- foreach(chr = seq(1, length(chr_unique)),
                       .combine = rbind) %dopar%
        dmr_parallel(dmc_df[dmc_df$CHR == chr_unique[chr],], DMC_count)
    stopCluster(cl = my.cluster)
    dmr_df <- dmr_mat[complete.cases(dmr_mat), , drop=FALSE]
    rownames(dmr_df) <- dmr_df$start_CpG
    select.results <- SummarizedExperiment(assays = dmr_df,
                                           metadata = list(chromosome_number=
                                                                chr_unique))
    RES <- dmrResults(as(select.results, "RangedSummarizedExperiment"))
    return(RES)}

#' HMM for beta valued DNA data
#'
#' This is the primary user interface for the \code{betaHMM} function
#' Generic S4 methods are implemented to eatimate the parameters of a
#' homogeneous hidden Markov model for the beta valued DNA methylation data.
#' The supported classes are \code{matrix}, \code{data.frame},
#' \code{RangedSummarizedExperiment} and \code{GRanges}. The output of
#' \code{betaHMM} method is an
#' S4 object of class \code{betaHMMResults}.
#'
#' @inheritParams betaHMMrun
#' @param methylation_data A dataframe of dimension \eqn{(C \times (N \times R)
#' )+1} containing methylation values for \eqn{C} CpG sites from \eqn{R}
#' treatment groups each having \eqn{N} DNA samples and the IlmnID
#' for each CpG site. Maybe provided as a matrix or data.frame, GRanges
#' or RangedSummarizedExperiment object.
#' @param annotation_file A dataframe containing the EPIC methylation
#' annotation file. Maybe provided as a matrix or data.frame, GRanges
#' or RangedSummarizedExperiment object.
#'
#' @return An S4 object of class \code{betaHMMResults}, where conditional
#' probabilities of each CpG site belonging to a hidden state is stored as a
#' SimpleList of assay data, and the corresponding estimated model parameters,
#' log-likelihood values, and most probable hidden state sequence for each
#' chromosome are stored as metadata.
#'
#' @aliases
#' betaHMM
#' betaHMM-methods
#' betaHMM,matrix,matrix-method
#' betaHMM,data.frame,data.frame-method
#' betaHMM,RangedSummarizedExperiment,RangedSummarizedExperiment.-method
#' betaHMM,matrix,data.frame-method
#' betaHMM,matrix,RangedSummarizedExperiment.-method
#' betaHMM,data.frame,matrix-method
#' betaHMM,data.frame,RangedSummarizedExperiment.-method
#' betaHMM,RangedSummarizedExperiment,data.frame-method
#' betaHMM,RangedSummarizedExperiment,matrix-method
#' betaHMM,GRanges,data.frame-method
#' betaHMM,GRanges,matrix-method
#' betaHMM,GRanges,RangedSummarizedExperiment-method
#' betaHMM,GRanges,GRanges-method
#' betaHMM,data.frame,GRanges-method
#' betaHMM,RangedSummarizedExperiment,GRanges-method
#' betaHMM,matrix,GRanges-method
#' @author Koyel Majumdar
#' @export
#' @keywords methods
#' @rdname betaHMM
#' @docType methods
#' @importFrom methods setMethod is as new
#' @importFrom stats p.adjust
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicRanges mcols
#' @example inst/examples/betaHMM_package.R
#'

setMethod("betaHMM", signature = signature(methylation_data = "matrix",
annotation_file = "matrix"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE, seed = NULL,iterations=100,...) {
data1 <- as.data.frame(methylation_data)
data2 <- as.data.frame(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})



##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "data.frame",
annotation_file = "data.frame"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- methylation_data
data2 <- annotation_file
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})


##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="RangedSummarizedExperiment",
annotation_file = "RangedSummarizedExperiment"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- assay(methylation_data)
data2 <- assay(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",signature=signature(methylation_data="GRanges",
annotation_file = "GRanges"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- as.data.frame(mcols(methylation_data))
data2 <- as.data.frame(mcols(annotation_file))
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="RangedSummarizedExperiment",
annotation_file = "matrix"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- assay(methylation_data)
data2 <- as.data.frame(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="RangedSummarizedExperiment",
annotation_file = "data.frame"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- assay(methylation_data)
data2 <- annotation_file
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="RangedSummarizedExperiment",
annotation_file = "GRanges"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,...) {
data1 <- assay(methylation_data)
data2 <- as.data.frame(mcols(annotation_file))
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "matrix",
annotation_file = "RangedSummarizedExperiment"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- as.data.frame(methylation_data)
data2 <- assay(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "data.frame",
annotation_file = "RangedSummarizedExperiment"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100,...) {
data1 <- methylation_data
data2 <- assay(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "data.frame",
annotation_file = "GRanges"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100,...) {
data1 <- methylation_data
data2 <- as.data.frame(mcols(annotation_file))
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "matrix",
annotation_file = "data.frame"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2,treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- as.data.frame(methylation_data)
data2 <- annotation_file
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
                    M = M, N = N, R = R, treatment_group = treatment_group,
                    parallel_process = parallel_process,
                    seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "matrix",
annotation_file = "GRanges"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2,treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- as.data.frame(methylation_data)
data2 <- as.data.frame(mcols(annotation_file))
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="GRanges",
annotation_file = "matrix"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- as.data.frame(mcols(methylation_data))
data2 <- as.data.frame(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="GRanges",
annotation_file = "data.frame"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- as.data.frame(mcols(methylation_data))
data2 <- annotation_file
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM",
signature=signature(methylation_data="GRanges",
annotation_file = "RangedSummarizedExperiment"),
definition = function(methylation_data, annotation_file,
M = 3, N = 4, R = 2, treatment_group = NULL, parallel_process = FALSE,
seed = NULL,iterations=100, ...) {
data1 <- as.data.frame(mcols(methylation_data))
data2 <- assay(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})
##############################################################################
#' @rdname betaHMM
#' @export
setMethod("betaHMM", signature = signature(methylation_data = "data.frame",
annotation_file = "matrix"), definition = function(methylation_data,
annotation_file, M = 3, N = 4, R = 2, treatment_group = NULL,
parallel_process = FALSE,
seed = NULL,iterations=100,
...) {
data1 <- methylation_data
data2 <- as.data.frame(annotation_file)
run <- betaHMMrun(methylation_data = data1, annotation_file = data2,
M = M, N = N, R = R, treatment_group = treatment_group,
parallel_process = parallel_process,
seed = seed,iterations=iterations, ...)
return(run)
})

##############################################################################
#' Accessors for the betaHMM package.
#'
#' The accessor methods for accessing the betaHMMResults/ dmcResults/
#' dmrResults/ threshold_Results metadata.
#'
#' @docType methods
#' @rdname packageHelpers
#' @aliases
#' annotatedData
#' annotatedData,betaHMMResults-method
#' annotatedData,threshold_Results-method
#' K
#' K,RangedSummarizedExperiment-method
#' K,betaHMMResults-method
#' K,dmcResults-method
#' K,threshold_Results-method
#' K,NULL-method
#' N
#' N,RangedSummarizedExperiment-method
#' N,betaHMMResults-method
#' N,dmcResults-method
#' N,NULL-method
#' R
#' R,RangedSummarizedExperiment-method
#' R,betaHMMResults-method
#' R,dmcResults-method
#' R,NULL-method
#' A
#' A,RangedSummarizedExperiment-method
#' A,betaHMMResults-method
#' A,NULL-method
#' tau
#' tau,RangedSummarizedExperiment-method
#' tau,betaHMMResults-method
#' tau,NULL-method
#' phi
#' phi,RangedSummarizedExperiment-method
#' phi,betaHMMResults-method
#' phi,threshold_Results-method
#' phi,NULL-method
#' llk
#' llk,RangedSummarizedExperiment-method
#' llk,betaHMMResults-method
#' llk,NULL-method
#' treatment_group
#' treatment_group,RangedSummarizedExperiment-method
#' treatment_group,betaHMMResults-method
#' treatment_group,dmcResults-method
#' treatment_group,NULL-method
#' hidden_states
#' hidden_states,RangedSummarizedExperiment-method
#' hidden_states,betaHMMResults-method
#' hidden_states,threshold_Results-method
#' hidden_states,NULL-method
#' model_parameters
#' model_parameters,RangedSummarizedExperiment-method
#' model_parameters,threshold_Results-method
#' model_parameters,NULL-method
#' threshold
#' threshold,RangedSummarizedExperiment-method
#' threshold,threshold_Results-method
#' threshold,NULL-method
#' @param object a \code{betaHMMResults}/ \code{dmcResults}/
#' \code{threshold_Results} object.
#' @return Output varies depending on the method.
#' @export
#' @example inst/examples/betaHMM_package.R
setMethod("annotatedData", "betaHMMResults",
            function(object) object@annotatedData)

#' @rdname packageHelpers
#' @export
setMethod("annotatedData", "threshold_Results",
            function(object) object@annotatedData)

### K
#' @rdname packageHelpers
#' @export
setMethod("K", "RangedSummarizedExperiment",
            function(object) metadata(object)$K)

#' @rdname packageHelpers
#' @export
setMethod("K", "betaHMMResults", function(object) metadata(object)$K)
#' @rdname packageHelpers
#' @export
setMethod("K", "dmcResults", function(object) metadata(object)$K)

#' @rdname packageHelpers
#' @export
setMethod("K", "threshold_Results", function(object) metadata(object)$K)

#' @rdname packageHelpers
#' @export
setMethod("K", "NULL", function(object) NA)

### N
#' @rdname packageHelpers
#' @export
setMethod("N", "RangedSummarizedExperiment",
            function(object) metadata(object)$N)

#' @rdname packageHelpers
#' @export
setMethod("N", "betaHMMResults", function(object) metadata(object)$N)

#' @rdname packageHelpers
#' @export
setMethod("N", "dmcResults", function(object) metadata(object)$N)



#' @rdname packageHelpers
#' @export
setMethod("N", "NULL", function(object) NA)

### R
#' @rdname packageHelpers
#' @export
setMethod("R", "RangedSummarizedExperiment",
            function(object) metadata(object)$R)

#' @rdname packageHelpers
#' @export
setMethod("R", "betaHMMResults", function(object) metadata(object)$R)


#' @rdname packageHelpers
#' @export
setMethod("R", "dmcResults", function(object) metadata(object)$R)



#' @rdname packageHelpers
#' @export
setMethod("R", "NULL", function(object) NA)

### A
#' @rdname packageHelpers
#' @export
setMethod("A", "RangedSummarizedExperiment",
            function(object) metadata(object)$A)

#' @rdname packageHelpers
#' @export
setMethod("A", "betaHMMResults", function(object) metadata(object)$A)

#' @rdname packageHelpers
#' @export
setMethod("A", "NULL", function(object) NA)


### tau
#' @rdname packageHelpers
#' @export
setMethod("tau", "RangedSummarizedExperiment",
            function(object) metadata(object)$tau)

#' @rdname packageHelpers
#' @export
setMethod("tau", "betaHMMResults", function(object) metadata(object)$tau)

#' @rdname packageHelpers
#' @export
setMethod("tau", "NULL", function(object) NA)


### treatment_group
#' @rdname packageHelpers
#' @export
setMethod("treatment_group", "RangedSummarizedExperiment",
    function(object) metadata(object)$treatment_group)

#' @rdname packageHelpers
#' @export
setMethod("treatment_group", "betaHMMResults",
            function(object) metadata(object)$treatment_group)

#' @rdname packageHelpers
#' @export
setMethod("treatment_group", "dmcResults",
            function(object) metadata(object)$treatment_group)


#' @rdname packageHelpers
#' @export
setMethod("treatment_group", "NULL", function(object) NA)


### llk
#' @rdname packageHelpers
#' @export
setMethod("llk", "RangedSummarizedExperiment",
            function(object) metadata(object)$llk)

#' @rdname packageHelpers
#' @export
setMethod("llk", "betaHMMResults", function(object) metadata(object)$llk)

#' @rdname packageHelpers
#' @export
setMethod("llk", "NULL", function(object) NA)

### phi
#' @rdname packageHelpers
#' @export
setMethod("phi", "RangedSummarizedExperiment",
            function(object) metadata(object)$phi)

#' @rdname packageHelpers
#' @export
setMethod("phi", "betaHMMResults", function(object) metadata(object)$phi)

#' @rdname packageHelpers
#' @export
setMethod("phi", "threshold_Results", function(object) metadata(object)$phi)

#' @rdname packageHelpers
#' @export
setMethod("phi", "NULL", function(object) NA)


### hidden_states
#' @rdname packageHelpers
#' @export
setMethod("hidden_states", "RangedSummarizedExperiment",
    function(object) metadata(object)$hidden_states)

#' @rdname packageHelpers
#' @export
setMethod("hidden_states", "betaHMMResults",
            function(object) metadata(object)$hidden_states)

#' @rdname packageHelpers
#' @export
setMethod("hidden_states", "threshold_Results",
            function(object) metadata(object)$hidden_states)

#' @rdname packageHelpers
#' @export
setMethod("hidden_states", "NULL", function(object) NA)


### chromosome_number
#' @rdname packageHelpers
#' @export
setMethod("chromosome_number", "RangedSummarizedExperiment",
    function(object) metadata(object)$chromosome_number)

#' @rdname packageHelpers
#' @export
setMethod("chromosome_number", "betaHMMResults",
            function(object) metadata(object)$chromosome_number)

#' @rdname packageHelpers
#' @export
setMethod("chromosome_number", "dmrResults",
            function(object) metadata(object)$chromosome_number)

#' @rdname packageHelpers
#' @export
setMethod("chromosome_number", "NULL", function(object) NA)

#' @rdname packageHelpers
#' @export
setMethod("AUC", "RangedSummarizedExperiment",
            function(object) metadata(object)$AUC)

#' @rdname packageHelpers
#' @export
setMethod("AUC", "dmcResults", function(object) metadata(object)$AUC)

#' @rdname packageHelpers
#' @export
setMethod("AUC", "NULL", function(object) NA)

### conditional probability values
#' @rdname packageHelpers
#' @export
setMethod("uncertainty", "RangedSummarizedExperiment",
    function(object) metadata(object)$uncertainty)

#' @rdname packageHelpers
#' @export
setMethod("uncertainty", "dmcResults",
            function(object) metadata(object)$uncertainty)

#' @rdname packageHelpers
#' @export
setMethod("uncertainty", "NULL", function(object) NA)


#' @rdname packageHelpers
#' @export
setMethod("model_parameters", "RangedSummarizedExperiment",
    function(object) metadata(object)$model_parameters)

#' @rdname packageHelpers
#' @export
setMethod("model_parameters", "threshold_Results",
    function(object) metadata(object)$model_parameters)

#' @rdname packageHelpers
#' @export
setMethod("model_parameters", "NULL", function(object) NA)

### threshold
#' @rdname packageHelpers
#' @export
setMethod("threshold", "RangedSummarizedExperiment",
    function(object) metadata(object)$threshold)

#' @rdname packageHelpers
#' @export
setMethod("threshold", "threshold_Results",
            function(object) metadata(object)$threshold)

#' @rdname packageHelpers
#' @export
setMethod("threshold", "NULL", function(object) NA)


### DMR methods
#' @title DMR identification from DMCs identified
#' @description This is the primary user interface for the
#' \code{\link[betaHMM:dmr_identification]{dmr_identification}} function.
#' Generic S4 methods are implemented to identify the DMRs from the DMCs
#' identified in each chromosome. The supported classes are \code{data.frame}
#' and \code{\link[betaHMM:dmcResults]{dmcResults}} object. The output is an
#' S4 object of class \code{\link[betaHMM:dmrResults]{dmrResults}}.
#' @rdname dmr_identification
#' @aliases
#' dmr_identification
#' dmr_identification-methods
#' dmr_identification,dmcResults-method
#' @export
#' @seealso \code{\link{betaHMM}}
#' @inheritParams dmr_identification_run
#' @param dmc_identification_object a
#' \code{\link[betaHMM:dmcResults]{dmcResults}} object or the assay data
#' from the dmcResults.
#' @return An S4 object of class \code{\link[betaHMM:dmrResults]{dmrResults}}
#' where the CpG site information for each DMR is stored as a SimpleList
#' of assay data and the chromosomes analysed by the model is stored as
#' the metadata.
#' @importFrom stats complete.cases
#' @example inst/examples/betaHMM_package.R
#'
setMethod(f = "dmr_identification",
            signature(dmc_identification_object = "dmcResults"),
            definition = function(dmc_identification_object, DMC_count = 2,
                                ...) {
            object_df <- assay(dmc_identification_object)
            dmr_df <-dmr_identification_run(dmc_identification_object =
                                            object_df,
                                            DMC_count = DMC_count, ...)
        return(dmr_df)
    })



##############################################################################
#' @rdname dmr_identification
#' @export
setMethod(f="dmr_identification",
            signature = signature(dmc_identification_object = "matrix"),
            definition = function(dmc_identification_object, DMC_count = 2,
                                ...) {
            dmc_identification_object <-
                as.data.frame(dmc_identification_object)
            dmr_df <- dmr_identification_run(dmc_identification_object =
                                                dmc_identification_object,
                                                DMC_count = DMC_count, ...)
        return(dmr_df)
    })



##############################################################################
#' @rdname dmr_identification
#' @export
setMethod(f="dmr_identification",
            signature(dmc_identification_object = "data.frame"),
    definition = function(dmc_identification_object, DMC_count = 2,
                                ...) {
            dmr_df <- dmr_identification_run(dmc_identification_object =
                                                dmc_identification_object,
                                                DMC_count = DMC_count, ...)
        return(dmr_df)
    })

### DMC methods
#' @title DMC identification from estimated betaHMM model parameters
#' @description This is the primary user interface for the
#' \code{\link[betaHMM:dmc_identification]{dmc_identification}} function.
#' Generic S4 methods are implemented to identify the DMCs from the estimated
#' betaHMM model parameters for each chromosome. The supported class is a
#'  \code{\link[betaHMM:betaHMMResults]{betaHMMResults}} object. The output
#'  is an S4 object of class of \code{\link[betaHMM:dmcResults]{dmcResults}}.
#' @rdname dmc_identification
#' @aliases
#' dmc_identification
#' dmc_identification-methods
#' dmc_identification,betaHMMResults-method
#' @export
#' @seealso \code{\link{betaHMM}}
#' @inheritParams dmc_identification_run
#' @param betaHMM_object An S4 object of class
#'  \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}
#' @return An S4 object of class \code{\link[betaHMM:dmcResults]{dmcResults}}.
#' @importFrom stats complete.cases
#' @example inst/examples/betaHMM_package.R
#'
setMethod(f = "dmc_identification",
            signature(betaHMM_object = "betaHMMResults"),
    definition = function(betaHMM_object, AUC_threshold = 0.8,
        uncertainty_threshold = 0.2, ...) {

        dmc_df <- dmc_identification_run(betaHMM_object = betaHMM_object,
            AUC_threshold = AUC_threshold,
            uncertainty_threshold = uncertainty_threshold,
            ...)
        return(dmc_df)
    })



## Threshold indentification function
#' HMM for beta valued DNA data for a single treatment condition
#'
#' The supported classes are \code{matrix} and \code{data.frame}.
#' The output of \code{threshold_identification} is an S4 object of
#' class \code{threshold_Results}.
#'
#' @inheritParams threshold_identification_run
#' @param object1 Methylation data and IlmnID. Maybe provided as a matrix
#' or dataframe.
#' @return
#' An S4 object of class \code{threshold_Results}.
#'
#' @aliases
#' threshold_identification
#' threshold_identification-methods
#' threshold_identification,matrix-method
#' threshold_identification,data.frame-method
#' @export
#' @rdname threshold_identification
#' @importFrom methods setMethod is as new
#' @importFrom stats p.adjust
#' @examples
#' ## Use simulated data for the betaHMM workflow example
#' set.seed(12345)
#' library(betaHMM)
#'
#' ## read files
#' data(sample_methylation_file)
#' head(sample_methylation_file)
#' data(sample_annotation_file)
#' head(sample_annotation_file)
#' ##merge data
#' df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
#' sample_methylation_file,by='IlmnID')
#'
#' ## sort data
#' df=df[order(df$CHR,df$MAPINFO),]
#' thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
#' parameter_estimation_only=TRUE,seed=12345)
#'

setMethod("threshold_identification",
            signature = signature(object1 = "matrix"),
    definition = function(object1, package_workflow = TRUE,
        annotation_file = NULL, M = 3, N = 4,
        parameter_estimation_only = FALSE,
        seed = NULL, ...) {
        data1 <- as.data.frame(object1)
        run <- threshold_identification_run(data = data1,
            package_workflow = package_workflow,
            annotation_file = annotation_file,
            M = M, N = N,
            parameter_estimation_only = parameter_estimation_only,
            seed = seed, ...)
        return(run)
    })



##############################################################################
#' @rdname threshold_identification
#' @export
setMethod("threshold_identification",
            signature = signature(object1 = "data.frame"),
    definition = function(object1, package_workflow = TRUE,
        annotation_file = NULL, M = 3, N = 4,
        parameter_estimation_only = FALSE,
        seed = NULL, ...) {
        data1 <- object1
        run <- threshold_identification_run(data = data1,
            package_workflow = package_workflow,
            annotation_file = annotation_file,
            M = M, N = N,
            parameter_estimation_only = parameter_estimation_only,
            seed = seed, ...)
        return(run)
    })

##############################################################################

#' @rdname betaHMMResults
#' @export
#' @importFrom methods setClass is as new
#' @importFrom SummarizedExperiment assay
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment



setClass("betaHMMResults",
            contains = "RangedSummarizedExperiment",
            representation = representation(annotatedData="DataFrame"))

setValidity("betaHMMResults",function(object){
    if(nrow(object@annotatedData)!=nrow(object@assays) &
       ncol(object@assays)!=object@metadata[[1]])
    {
        "Conditional posterior probability needs to be calculated for each
        of the CpG sites and K hidden states."
    }
})


#' betaHMMResults object and constructor
#'
#' \code{betaHMMResults} is a subclass of \code{RangedSummarizedExperiment},
#' used to store the betaHMM results as well as the annotated data useful
#'  for plotting.
#'
#' This constructor function would not typically be used by "end users".
#' This simple class extends the \code{RangedSummarizedExperiment} class of the
#' SummarizedExperiment package
#' to allow other packages to write methods for results
#' objects from the betaHMM package. It is used by
#' to wrap up the results table.
#'
#' @param SummarizedExperiment a \code{RangedSummarizedExperiment} of
#' \code{betaHMM} results
#' @param annotatedData The annotated data passed as an input argument to
#' the betaHMM package.
#'
#'
#' @return a betaHMMResults object
#' @docType class
#' @rdname betaHMMResults
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom S4Vectors DataFrame
#' @export
#' @example inst/examples/betaHMM_package.R
betaHMMResults <- function(SummarizedExperiment,annotatedData) {
    se_obj<-se(SummarizedExperiment)
    annotatedData<-anno_data(annotatedData)
    object <- new("betaHMMResults", se_obj, annotatedData=annotatedData)
    return(object)
    }

#' @rdname dmrResults
#' @export
#' @importFrom SummarizedExperiment assay
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment

setClass("dmrResults",
            contains = "RangedSummarizedExperiment")


setValidity("dmrResults",function(object){
    x<-as.data.frame(assay(object))
    if(any(is.na(x[,seq_len(2)])))
    {
        "Starting and ending CpG sites of a DMR cannot be empty."
    }
})


#' dmrResults object and constructor
#'
#' \code{dmrResults} is a subclass of \code{RangedSummarizedExperiment},
#' used to store the DMRs identified.
#'
#' This constructor function would not typically be used by "end users".
#' This simple class extends the \code{RangedSummarizedExperiment} class of the
#' SummarizedExperiment package
#' to allow other packages to write methods for results
#' objects from the
#' \code{\link[betaHMM:dmr_identification]{dmr_identification}} function.
#' It is used by
#' to wrap up the results table.
#'
#' @param SummarizedExperiment a \code{dmrResults}
#' results.
#'
#'
#' @return a  \code{\link[betaHMM:dmrResults]{dmrResults}} object
#' @docType class
#' @rdname dmrResults
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom S4Vectors DataFrame
#' @export
#' @example inst/examples/betaHMM_package.R
dmrResults <- function(SummarizedExperiment) {
    se_obj<-se(SummarizedExperiment)
    object <- new("dmrResults", se_obj)
    return(object)
}




#' @rdname dmcResults
#' @export
#' @importFrom methods setClass
#' @importFrom SummarizedExperiment assay
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment


setClass("dmcResults",
            contains = "RangedSummarizedExperiment")


setValidity("dmcResults",function(object){
    if(nrow(object@assays) !=length(unlist(object@metadata[[6]])))
    {
        "Uncertainty needs to be calculated for each CpG site analysed."
    }
})


#' dmcResults object and constructor
#'
#' \code{dmcResults} is a subclass of \code{RangedSummarizedExperiment},
#' used to store the DMCs identified.
#'
#' This constructor function would not typically be used by "end users".
#' This simple class extends the \code{RangedSummarizedExperiment} class of the
#' SummarizedExperiment package
#' to allow other packages to write methods for results
#' objects from the
#' \code{\link[betaHMM:dmc_identification]{dmc_identification}} function.
#' It is used by
#' to wrap up the results table.
#'
#' @param SummarizedExperiment a \code{RangedSummarizedExperiment} of
#' \code{dmcResults} results.
#'
#'
#' @return a \code{\link[betaHMM:dmcResults]{dmcResults}} object
#' @docType class
#' @rdname dmcResults
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom S4Vectors DataFrame
#' @export
#' @example inst/examples/betaHMM_package.R
dmcResults <- function(SummarizedExperiment) {
    se_obj<-se(SummarizedExperiment)
    object <- new("dmcResults", se_obj)
    return(object)
}


## Threshold definition

#' @rdname threshold_Results
#' @export
#' @importFrom methods setClass
#' @importFrom SummarizedExperiment assay
#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment


setClass("threshold_Results",
            contains = "RangedSummarizedExperiment",
            representation = representation(
            annotatedData="DataFrame"

            ))


setValidity("threshold_Results",function(object){
    if(nrow(object@annotatedData)!=nrow(object@assays) &
       ncol(object@assays)!=object@metadata[[2]])
    {
        "Conditional posterior probability needs to be calculated for each
        of the CpG sites and K hidden states."
    }
})


#' threshold_Results object and constructor
#'
#' \code{threshold_Results} is a subclass of \code{RangedSummarizedExperiment},
#' used to store the threshold_identification results as well as the annotated
#'  data useful for plotting.
#'
#' This constructor function would not typically be used by "end users".
#' This simple class extends the \code{RangedSummarizedExperiment} class of the
#' SummarizedExperiment package
#' to allow other packages to write methods for results
#' objects from the
#' \code{\link[betaHMM:threshold_identification]{threshold_identification}}
#' function. It is used by
#' to wrap up the results table.
#'
#' @param SummarizedExperiment a \code{RangedSummarizedExperiment} of
#' \code{threshold_Results} object.
#' @param annotatedData The annotated data passed as an input argument to
#' the \code{threshold_identification} function.
#'
#'
#' @return a \code{\link[betaHMM:threshold_Results]{threshold_Results}} object
#' @docType class
#' @rdname threshold_Results
#' @importClassesFrom S4Vectors DataFrame
#' @importFrom S4Vectors DataFrame
#' @export
#' @examples
#' ## Use simulated data for the betaHMM workflow example
#' set.seed(12345)
#' library(betaHMM)
#'
#' ## read files
#' data(sample_methylation_file)
#' head(sample_methylation_file)
#' data(sample_annotation_file)
#' head(sample_annotation_file)
#' ##merge data
#' df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
#' sample_methylation_file,by='IlmnID')
#'
#' ## sort data
#' df=df[order(df$CHR,df$MAPINFO),]
#' thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
#' parameter_estimation_only=TRUE,seed=12345)
#'

threshold_Results <- function(SummarizedExperiment,
                            annotatedData) {
    se_obj<-se(SummarizedExperiment)
    annotatedData<-anno_data(annotatedData)
    object <- new("threshold_Results", se_obj, annotatedData=annotatedData)
    return(object)
}

#' @title Estimating the hidden states using Viterbi algorithm
#' @description The Viterbi algorithm is used to estimate the most probable
#' sequence of the hidden states utilizing the betaHMM model
#' parameters estimated by the Baum-Welch algorithm.
#' @keywords internal
#' @param data A dataframe of dimension \eqn{C \times (N \times R)} containing
#' methylation values for \eqn{C} CpG sites from \eqn{R}
#' treatment groups each having \eqn{N} replicates or each
#' collected from \eqn{N} patients.
#' @param M Number of methylation states to be identified
#' in a single DNA sample.
#' @param N Number of DNA samples (patients/replicates) collected for each
#' treatment group.
#' @param R Number of treatment groups (For. eg: Benign and Tumour).
#' @param A The transition matrix for the betaHMM model.
#' @param tau The initial distribution for the betaHMM model.
#' @param phi The shape parameters for the observation sequence data
#' in the betaHMM model.
#' @param K The number of hidden states identified using the betaHMM model.
#' @return A vector containing the most probable sequence of the hidden states
#' of the betaHMM model.
#' @importFrom stats dbeta
#'

Viterbi <- function(data, M, N, R, tau, A, phi,K) {
    C <- nrow(data)
    probabilities <- list()
    n1 <- 1
    n2 <- N[1]
    for (r in seq(1, R)) {
        if(K==M)
        {
            sp1<-phi$sp_1
            sp2<-phi$sp_2
        }else{
            sp1<-phi$sp_1[r, ]
            sp2<-phi$sp_2[r, ]
        }
        for (n in n1:n2) {
            probabilities[[n]] <- matrix(data[, n], ncol = K, nrow=nrow(data))
            probabilities[[n]] <- t(apply(X = probabilities[[n]], MARGIN = 1,
                                          FUN = dbeta,
                                          shape1 = sp1,
                                          shape2 = sp2))
        }
        if ((r + 1) <= R) {
            n1 <- n1 + N[r]
            n2 <- n2 + N[r + 1]
        }
    }
    prob_list <- lapply(probabilities, as.matrix)
    prob <- Reduce(`*`, prob_list[-1], init = prob_list[[1]])
    probabilities <- matrix(0, ncol = K, nrow = C)
    probabilities <- prob
    omega <- matrix(0, ncol = K, nrow = C)
    prob <- tau * probabilities[1, ]
    omega[1, ] <- prob/sum(prob)
    for (c in 2:C) {
        prob <- apply(omega[c - 1, ] * A, 2, max) * probabilities[c, ]
        omega[c, ] <- prob/sum(prob)
    }
    decoding <- numeric(C)
    decoding[C] <- which.max(omega[C, ])
    for (c in (C - 1):1) {
        decoding[c] <- which.max(A[, decoding[c + 1]] * omega[c, ])
    }
    return(decoding)
}

#' @title Initialising the betaHMM model parameters
#' @description Initialise the betaHMM model parameters.
#' @details Computes the shape parameters using the threshold_function to
#' initialise the shape parameters of the model.
#' @keywords internal
#' @param data A dataframe of dimension \eqn{C \times (N \times R)} containing
#' methylation values for \eqn{C} CpG sites from \eqn{R}
#' treatment groups each having \eqn{N} replicates or each
#' collected from \eqn{N} patients.
#' @param M Number of methylation states to be identified in a DNA sample.
#' @param N Number of patients or DNA sample replicates collected for each
#' treatment group.
#' @param R Number of treatment groups (For. eg: Benign and Tumour).
#' @param seed Seed to allow for reproducibility (default = NULL).
#' @return A list containing:
#' \itemize{
#' \item A - The transition matrix for the betaHMM model.
#' \item tau - The initial distribution for the betaHMM model.
#' \item phi - The shape parameters for the observation sequence data
#' in the betaHMM model.}
#' @importFrom stats kmeans
#' @importFrom stats sd

initialise_parameters <- function(data, M, N, R, seed = NULL) {
    K <- M^R
    A <- 0.6 * diag(K) + rep(0.05/K, K)  ## transmission probabilities
    tau <- rep(1/K, K)  ## initial mixing proportions
    sh_p1 <- list()
    sh_p2 <- list()
    data_ilmnid <- data[, "IlmnID"]
    data <- subset(data, select = -c(IlmnID))
    process_r <- function(r, data_ilmnid, data, N,n1,n2) {
        start<-n1[r]
        end<-n2[r]
        data_th <- cbind(data_ilmnid, data[, start:end, drop = FALSE])
        data_th <- as.data.frame(data_th)
        colnames(data_th)[1] <- "IlmnID"
        threshold_out <- threshold_identification(data_th,
                                                  package_workflow = TRUE,
                                                  M = 3, N = N[r],
                                                  parameter_estimation_only =
                                                      TRUE, seed = 321)
        model_params <- model_parameters(threshold_out)
        alpha <- model_params$phi$sp_1
        beta <- model_params$phi$sp_2
        alpha <- sort(alpha)
        delta <- sort(beta, decreasing = TRUE)
        alpha[2] <- 1
        delta[2] <- 1
        return(list(alpha=alpha,delta=delta))
    }
    indices <- seq(1, R)
    n1<-vector()
    n2<-vector()
    n1[1]<-1
    n2[1]<-N[1]
    n1 <- c(1, cumsum(N[-R]+1))
    n2 <- cumsum(N)
    result<-lapply(indices, process_r, data_ilmnid = data_ilmnid,
                   data = data, N = N,n1,n2)
    alpha_df <- do.call(rbind,
                        lapply(result,
                               function(res) as.data.frame(t(res$alpha))))
    delta_df <- do.call(rbind,
                        lapply(result,
                               function(res) as.data.frame(t(res$delta))))
    sh_p1 <- lapply(seq_len(nrow(alpha_df)),
                    function(i) as.vector(as.numeric(alpha_df[i, ])))
    sh_p2 <- lapply(seq_len(nrow(delta_df)),
                    function(i) as.vector(as.numeric(delta_df[i, ])))
    x1 <- do.call(expand.grid, sh_p1)
    x2 <- do.call(expand.grid, sh_p2)
    x1 <- t(x1)
    x2 <- t(x2)
    phi <- list(sp_1 = x1, sp_2 = x2)
    rownames(phi$sp_1) <- NULL
    rownames(phi$sp_2) <- NULL
    return(list(A = A, tau = tau, phi = phi))
}

#' @title Simulated DNA methylation data
#'
#' @description A dataset containing simulated beta methylation values from
#' \eqn{R=2} sample types (Benign and Tumour), collected from \eqn{N=4}
#' patients.
#'
#' @details The array data were then normalized and and probes located outside
#' of CpG sites and on the sex chromosome were filtered out. The CpG sites with
#' missing values were removed from the resulting dataset. A subset of the
#' complete dataset has been uploaded in the package for testing purposes.
#' The complete dataset is available on
#' \href{https://github.com/koyelucd/betaHMM}{GitHub}.
#' @seealso \code{\link{sample_annotation_file}}
#' @format A data frame with 100 rows and 9 columns. The data contain no
#' missing values.
#' \itemize{
#' \item{IlmnID: The unique identifier from the Illumina CG database,
#' i.e. the probe ID.}
#' \item{Benign_Patient_1: Methylation values from benign tissue from
#' patient 1.}
#' \item{Benign_Patient_2: Methylation values from benign tissue from
#' patient 2.}
#' \item{Benign_Patient_3: Methylation values from benign tissue from
#' patient 3.}
#' \item{Benign_Patient_4: Methylation values from benign tissue from
#' patient 4.}
#' \item{Tumour_Patient_1: Methylation values from tumor tissue from
#' patient 1.}
#' \item{Tumour_Patient_2: Methylation values from tumor tissue from
#' patient 2.}
#' \item{Tumour_Patient_3: Methylation values from tumor tissue from
#' patient 3.}
#' \item{Tumour_Patient_4: Methylation values from tumor tissue from
#' patient 4.}}
#' @usage data(sample_methylation_file)
#' @return The data frame containing simulated methylation values.
"sample_methylation_file"

## ----setup, include = FALSE---------------------------------------------------
knitr::include_graphics("betaHMM_hex.png")
options(rmarkdown.html_vignette.check_title = FALSE)
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(eval = TRUE)

#knitr::opts_chunk$set(dev = 'png')
#knitr::opts_chunk$set(dpi=100)

## ----biocsetup, eval=FALSE----------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# # The following initializes usage of Bioc devel
# BiocManager::install(version='devel')
# 
# BiocManager::install("betaHMM")

## ----package, include=TRUE, echo=TRUE, message=FALSE,warning=FALSE------------
library(betaHMM)

## ----data,include=TRUE, echo=TRUE---------------------------------------------
data(pca_methylation_data)
head(pca_methylation_data)
data(annotation_data)
head(annotation_data)



## ----betaHMM,include=TRUE, echo=TRUE------------------------------------------
M <- 3 ## No. of methylation states in a DNA sample type
N <- 4 ## No. of patients
R <- 2 ## No. of treatment conditions
my.seed <- 321 ## set seed for reproducibility

betaHMM_out <- betaHMM(pca_methylation_data,
                                annotation_data,
                                M = 3,
                                N = 4,
                                R = 2,
                                parallel_process = FALSE,
                                seed = my.seed,
                                treatment_group = c("Benign","Tumour"))

## ----betaHMMclass,include=TRUE, echo=TRUE-------------------------------------
class(betaHMM_out)

## ----betaHMMaccessor,include=TRUE, echo=TRUE----------------------------------
## transition matrix estimated for all chromosomes
A(betaHMM_out)

## Shape parameters estimated for a certain chromosome
phi(betaHMM_out)

## Hidden states assigned to all CpG sites for a certain chromosome
head(hidden_states(betaHMM_out)[["chr 7"]])

## ----betaHMMsummary,include=TRUE, echo=TRUE-----------------------------------
summary(betaHMM_out)

## ----dmc,include=TRUE, echo=TRUE----------------------------------------------
dmc_out <- dmc_identification(betaHMM_out)
dmc_df <- assay(dmc_out)
head(dmc_df)

## ----dmcsummary,include=TRUE, echo=TRUE---------------------------------------
summary(dmc_out)

## ----betaHMMplot,include=TRUE,echo=TRUE,fig.width=8,fig.height=5,dev='png'----
AUC_chr <- AUC(dmc_out)
plot(betaHMM_out, chromosome = "7", what = "fitted density", AUC = AUC_chr)

## ----betaHMMplot2,include=TRUE,echo=TRUE,fig.width=6,fig.height=5,dev='png'----
plot(betaHMM_out, chromosome = "7", what = "uncertainty",
        uncertainty_threshold = 0.2)

## ----dmr,include=TRUE, echo=TRUE----------------------------------------------
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)
dmr_df <- assay(dmr_out)
head(dmr_df)

## ----dmrsummary,include=TRUE, echo=TRUE---------------------------------------
summary(dmr_out)

## ----dmrplot,include=TRUE,echo=TRUE,fig.width=7,fig.height = 5, dev = 'png'----
plot(dmc_out, start_CpG = "cg17750844", end_CpG = 15)

## ----threshold,include=TRUE, echo=TRUE----------------------------------------
threshold_out <- threshold_identification(pca_methylation_data[,1:5],
                                            package_workflow = FALSE,
                                            annotation_file = annotation_data,
                                            M = 3,
                                            N = 4,
                                            parameter_estimation_only = FALSE,
                                            seed = my.seed)
threshold(threshold_out)

## ----thresholdplot,include=TRUE,echo=TRUE,fig.width=5,fig.height=4,dev='png'----
plot(threshold_out, plot_threshold = TRUE, what = "fitted density")

## -----------------------------------------------------------------------------
sessionInfo()

globalVariables(c("Patient_Sample", "label", "Uncertainty", "M", "beta_value"))
#' Visualize results from \code{betaHMM}/ \code{dmc_identification}/
#' \code{threshold_identification} functions.
#'
#' @rdname plot
#' @aliases
#' plot
#' plot-methods
#' plot,betaHMMResults-method
#'
#' @param x An object of class
#' \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}/
#' \code{\link[betaHMM:dmcResults]{dmcResults}}/
#' \code{\link[betaHMM:dmcResults]{threshold_Results}} object.
#' @param chromosome The chromosome number for which the plot is to be
#' displayed.
#' @param what The different plots that can be obtained are either
#' 'fitted density','kernel density' or
#' 'uncertainty' (default = 'fitted density').
#' @param treatment_group The names of the different treatment groups
#' to be displayed in the plot.If no value is passed then the sample names
#' estimated by the \code{betaHMM} function are used.
#' @param AUC The AUC values for that chromosome.
#' @param uncertainty_threshold The uncertainty threshold value used for DMC
#' identification.
#' @param title The title that the user wants to display.
#' If no title is to be displayed the default is 'NULL'.
#' @param ... Other graphics parameters.
#'
#' @return This function displays the following plots as requested by the user
#' when analysing the \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}
#' output:
#' \itemize{
#' \item fitted density estimates - Plot showing the fitted density estimates
#' of the clustering solution under the optimal model selected.
#' \item kernel density estimates - Plot showing the kernel density estimates
#' of the clustering solution under the optimal model selected.
#' \item uncertainty -  A boxplot showing the uncertainties in the
#' hidden state estimation.
#' }
#' @author Koyel Majumdar
#'
#' @export
#' @example inst/examples/betaHMM_package.R
#' @importFrom ggplot2 ggplot aes
#' @importFrom stats C density
#' @importFrom scales seq_gradient_pal
#'
setMethod(f = "plot", signature(x = "betaHMMResults"),
            definition = function(x, chromosome = NULL,
                                what = c("fitted density", "kernel density",
    "uncertainty"), treatment_group = NULL, AUC = NULL,
    uncertainty_threshold = 0.2, title = NULL, ...) {
    graph_objects <- c()
    object <- x
    graph_objects <- betaHMMGlobalplots(object,
                                        chromosome = chromosome,
                                        what = what,
                                        treatment_group = treatment_group,
                                        AUC = AUC,
                                        uncertainty_threshold =
                                            uncertainty_threshold,
                                        title = title, ...)
    return(graph_objects)
})

betaHMMGlobalplots<-function(x,chromosome=NULL,what="fitted density",
                              treatment_group=NULL,AUC=NULL,
                              uncertainty_threshold=0.2, title = NULL, ...) {
    if (is.null(chromosome)) stop("Chromosome number cannot be empty")
    chromosome <- as.numeric(chromosome)
    object <- x
    plotdata <- annotatedData(object)
    plotdata <- as.data.frame(plotdata)
    label_chromosome <- paste("chr", chromosome, sep = " ")
    R <- R(object)
    N <- N(object)
    C <- nrow(data)
    K <- K(object)
    phi_complete <- phi(object)
    phi <- list()
    phi[["sp_1"]] <- phi_complete[[1]][[label_chromosome]]
    phi[["sp_2"]] <- phi_complete[[2]][[label_chromosome]]
    data_comp <- plotdata[plotdata$CHR == chromosome, ]
    data <- data_comp[, -c(seq(1, 3))]
    C <- nrow(data)
    hidden_states <- hidden_states(object)[[label_chromosome]]
    if (is.null(title)) {
        title_text <- ""
    } else {
        title_text <- title
    }
    if (is.null(treatment_group)) {
        treatment_group <- treatment_group(object)
    }
    if (!is.null(AUC)) {
        auc <- as.data.frame(AUC[[label_chromosome]])
        auc <- auc[order(auc$AUC, decreasing = TRUE), ]
        auc$label <- paste("State ", auc$State, ", AUC = ",
                           round(auc$AUC, 2), sep = "")
    } else {
        label <- seq(1, K)
        auc <- as.data.frame(label)
    }
    if (what == "kernel density") {
        plot_graph <- kernel_density_plot(data, hidden_states, auc, C,
                                          treatment_group, title_text)
    }
    if (what == "fitted density") {
        plot_graph <- fitted_density_plot(phi, hidden_states, auc, R, K, C,
                                          treatment_group, title_text)
    }
    if (what == "uncertainty") {
        z <- assay(object)
        plot_graph <- uncertainty_plots(data_comp, z, hidden_states, C,
                                        uncertainty_threshold, title_text)
    }
    return(plot_graph)
}

#' @title Forward algorithm
#' @description Computes the forward probabilities for \eqn{K} hidden states
#' using the initial distribution, transition matrix and distribution
#' parameters.
#' @keywords internal
#' @param probabilities A matrix containing the marginal probability
#' distribution of the \eqn{K} states within the Markov model.
#' @param trained_params A list containing the initialised shape parameters for
#' the betaHMM model (initial distribution, transition matrix, shape parameters
#' for the observed data).
#' @return A list containing:
#' \itemize{
#' \item log_alpha - A \eqn{C*K} matrix (where \eqn{C} is the number of CpG
#' sites and \eqn{K} is the number of hidden states) containing the
#' logarithmized forward probabilities.
#' \item scaled_logL - The log-likelihood calculated using the forward
#' probabilities.}

forward <- function(probabilities, trained_params) {
    C <- nrow(probabilities)
    K <- ncol(probabilities)
    log_alpha <- matrix(0, nrow = C, ncol = K)
    alpha <- trained_params$tau * probabilities[1, ]
    sum_of_alpha <- sum(alpha)
    scaled_logL <- log(sum_of_alpha)
    alpha <- alpha/sum_of_alpha
    log_alpha[1, ] <- scaled_logL + log(alpha)
    for (i in 2:C) {
        alpha <- alpha %*% trained_params$A * probabilities[i, ]
        sum_of_alpha <- sum(alpha)
        scaled_logL <- scaled_logL + log(sum_of_alpha)
        alpha <- alpha/sum_of_alpha
        log_alpha[i, ] <- scaled_logL + log(alpha)
    }

    return(list(log_alpha = log_alpha, scaled_logL = scaled_logL))
}

#' @rdname betaHMM
#' @export
setGeneric("betaHMM", function(methylation_data, annotation_file, ...)
standardGeneric("betaHMM"),
signature = c("methylation_data", "annotation_file"))


#' @rdname packageHelpers
#' @export
setGeneric("annotatedData", function(object) standardGeneric("annotatedData"))

#' @rdname packageHelpers
#' @export
setGeneric("K", function(object) standardGeneric("K"))



#' @rdname packageHelpers
#' @export
setGeneric("N", function(object) standardGeneric("N"))

#' @rdname packageHelpers
#' @export
setGeneric("R", function(object) standardGeneric("R"))

#' @rdname packageHelpers
#' @export
setGeneric("A", function(object) standardGeneric("A"))

#' @rdname packageHelpers
#' @export
setGeneric("phi", function(object) standardGeneric("phi"))

#' @rdname packageHelpers
#' @export
setGeneric("treatment_group", function(object)
    standardGeneric("treatment_group"))



#' @rdname packageHelpers
#' @export
setGeneric("llk", function(object) standardGeneric("llk"))

#' @rdname packageHelpers
#' @export
setGeneric("tau", function(object) standardGeneric("tau"))

#' @rdname packageHelpers
#' @export
setGeneric("hidden_states", function(object) standardGeneric("hidden_states"))

#' @rdname packageHelpers
#' @export
setGeneric("chromosome_number", function(object)
    standardGeneric("chromosome_number"))


#' @rdname plot
#' @export
setGeneric("plot", function(x, ...) standardGeneric("plot"))



#' @rdname summary
#' @export
setGeneric("summary", function(object, ...) standardGeneric("summary"))

#' @rdname dmr_identification
#' @export
setGeneric("dmr_identification",
            function(dmc_identification_object, ...)
    standardGeneric("dmr_identification"),
    signature = c("dmc_identification_object"))

#' @rdname dmc_identification
#' @export
setGeneric("dmc_identification", function(betaHMM_object, ...)
    standardGeneric("dmc_identification"), signature = c("betaHMM_object"))

#' @rdname packageHelpers
#' @export
setGeneric("AUC", function(object) standardGeneric("AUC"))

#' @rdname packageHelpers
#' @export
setGeneric("uncertainty", function(object) standardGeneric("uncertainty"))


#' @rdname threshold_identification
#' @export
setGeneric("threshold_identification", function(object1, ...)
    standardGeneric("threshold_identification"), signature = c("object1"))


#' @rdname packageHelpers
#' @export
setGeneric("model_parameters", function(object)
    standardGeneric("model_parameters"))


#' @rdname packageHelpers
#' @export
setGeneric("threshold", function(object) standardGeneric("threshold"))

globalVariables(c("Patient_Sample", "label", "M",
                    "beta_value", "name", "CP", "DMC", "group", "value"))
#'
#' @rdname plot
#' @aliases
#' plot
#' plot-methods
#' plot,dmcResults-method
#'
#' @param x An object of class
#' \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}/
#' \code{\link[betaHMM:dmcResults]{dmcResults}}/
#' \code{\link[betaHMM:dmcResults]{threshold_Results}} object.
#' @param start_CpG The IlmnID of starting CpG site when plotting the DMCs.
#' @param end_CpG The IlmnID of ending CpG site/ the total number
#' of CpGs to be plotted excluing the starting CpG site when plotting the DMCs.
#' @param treatment_group The names of the different treatment groups
#' to be displayed in the plot.If no value is passed then the sample names
#' estimated by the \code{betaHMM} function are used.
#' @param N The number of DNA samples corresponding to each
#' treatment group analysed using the betaHMM model. If `NULL`, the value from
#' \code{betaHMMResults} object is selected.
#' @param title The title that the user wants to display.
#' If no title is to be displayed the default is 'NULL'.
#' @param ... Other graphics parameters.
#'
#' @return The function displays the  DMCs and DMRs plot from
#' the \code{\link[betaHMM:dmcResults]{dmcResults}} object.
#'
#'
#' @author Koyel Majumdar
#'
#' @export
#'
#' @importFrom ggplot2 ggplot geom_point aes scale_shape_manual geom_line labs
#' @importFrom ggplot2 scale_colour_manual scale_fill_gradient guides
#' @importFrom ggplot2 theme ylab scale_x_discrete theme_void element_text
#' @importFrom ggplot2 element_blank
#' @importFrom tidyr pivot_longer %>%
#' @importFrom dplyr mutate
#' @importFrom cowplot plot_grid
#' @importFrom stats C
#' @importFrom scales seq_gradient_pal
#' @importFrom stringr str_split
#' @importFrom tidyselect all_of
#' @example inst/examples/betaHMM_package.R
setMethod(f = "plot", signature(x = "dmcResults"),
            definition = function(x, start_CpG = NULL, end_CpG = NULL,
                                treatment_group = NULL, N = NULL,
                                title = NULL, ...) {
    graph_objects <- c()
    object <- x
    graph_objects <- dmcGlobalplots(object, start_CpG = start_CpG,
                                    end_CpG = end_CpG,
                                    treatment_group = treatment_group,
                                    N = N, title = title, ...)
    return(graph_objects)
})

dmcGlobalplots<-function(x,start_CpG=NULL,end_CpG=NULL,treatment_group=NULL,
                         N = NULL, title = NULL, ...) {
    if (is.null(start_CpG)) stop("start_CpG cannot be empty.")
    if (is.null(end_CpG)) stop("end_CpG cannot be empty.")
    object <- x
    dmc_df <- as.data.frame(assay(object))
    if (is.numeric(end_CpG)) {start_index <- which(dmc_df$IlmnID == start_CpG)
    new_index<-start_index+end_CpG
    end_CpG<-dmc_df[new_index, "IlmnID"]}
    if (dmc_df[dmc_df$IlmnID == start_CpG, "CHR"] !=
        dmc_df[dmc_df$IlmnID == end_CpG, "CHR"])
        stop("Start and End CpGs cannot be from different Chromosomes.")
    chromosome <- dmc_df[dmc_df$IlmnID == start_CpG, "CHR"]
    ddcc<-dmc_df[dmc_df$CHR==chromosome,]
    label_chrom <- paste("chr", chromosome, sep = " ")
    ddcc$Uncertainty <- unlist(uncertainty(object)[[label_chrom]])
    si <- which(ddcc$IlmnID == start_CpG)
    ei <- which(ddcc$IlmnID == end_CpG)
    dmc_df_chr <- ddcc[si:ei, ]
    col_meth<-which(!(colnames(dmc_df_chr) %in% c("CHR","MAPINFO","IlmnID",
                                                  "hidden_state", "DMC",
                                                  "Uncertainty")))
    if (is.null(R)) { R <- R(object) }
    if (is.null(N)) { N <- N(object) }
    if (is.null(treatment_group)) { treatment_group<-treatment_group(object) }
    if (!is.null(N) & !is.null(treatment_group)) {
    group_name <- unlist(lapply(seq_along(treatment_group),
                                function(j) rep(treatment_group[j], N[j])))
    group_name <- paste(group_name, seq(1, length(group_name)), sep = "_")
    colnames(dmc_df_chr)[col_meth] <- group_name
    }
    cols <- colnames(dmc_df_chr)
    long_dat <- pivot_longer(dmc_df_chr, cols = all_of(col_meth)) %>%
        mutate(group=str_split(name,"_",simplify=TRUE)[, 1])
    g1<-ggplot(long_dat)+geom_point(aes(x=factor(MAPINFO),y=1,fill=Uncertainty,
                                        colour=factor(DMC)),shape=21,size=5,
                                    stroke=1.2)+theme_void()+
        scale_shape_manual(values=c(`1`=19,`0`=1))+
        scale_colour_manual(values=c(`1`="red",`0`="black"),
                            labels=c("non-DMC","DMC"),name=NULL)+
        scale_fill_gradient(low = "black", high = "white",name="Uncertainty")+
        guides(shape = "none") + labs(x = NULL, y = NULL) +
        theme(legend.position = "top", legend.justification = "right")
    g2<-ggplot(long_dat,aes(x=factor(MAPINFO),y=value,color=group,
                            group = name)) + geom_line() + theme_void() +
        ylab("beta value") +
        scale_x_discrete(labels = paste0(unique(long_dat$IlmnID), " ")) +
        theme(strip.background = element_blank(),
              strip.text.x = element_blank(), axis.text.y = element_blank(),
              axis.title.y=element_text(angle=90),
              axis.text.x=element_text(angle=90,hjust=.95,vjust=.2),
              legend.title=element_blank(),legend.position="bottom")
    plotG<-plot_grid(g1,g2,ncol=1,rel_heights=c(0.3,0.7),align="v",axis="l")
    return(plotG)}

---
title: "*betaHMM* package: Quick-start guide"
author: "Koyel Majumdar, Isobel Claire Gormley, Thomas Brendan Murphy, 
Romina Silva, Antoinette Sabrina Perry, Ronald William Watson, 
Florence Jaffrézic, Andrea Rau"
output: 
  BiocStyle::html_document:
    toc_float: true
  BiocStyle::pdf_document: default
always_allow_html: true
vignette: >
  %\VignetteIndexEntry{betaHMM}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}{inputenc}
---

```{r setup, include = FALSE}
knitr::include_graphics("betaHMM_hex.png")
options(rmarkdown.html_vignette.check_title = FALSE)
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(eval = TRUE)

#knitr::opts_chunk$set(dev = 'png')
#knitr::opts_chunk$set(dpi=100)
```

# Installation
To install this package, start R (version "4.3") and enter:

```{r biocsetup, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following initializes usage of Bioc devel
BiocManager::install(version='devel')

BiocManager::install("betaHMM")
```

# Introduction

DNA methylation, the addition of a methyl group to a cytosine-guanine
dinucleotide (CpG) site, is influenced by environmental factors and serves as a
disease biomarker. In diploid individuals, CpG sites are hypermethylated (both
strands methylated), hypomethylated (neither strand methylated), or
hemimethylated (one strand methylated). Identifying differentially methylated
CpG sites (DMC) and regions (DMR) can reveal the impact of environmental
stressors.

Methylation levels, called beta values, represent the proportion of methylated
probes, usually modeled with beta distributions. They are often logit
transformed into M-values for modeling. To directly model beta values and
account for spatial correlation between CpG sites, we propose a homogeneous
hidden Markov model (HMM) approach called betaHMM. It identifies DMCs and DMRs
while considering spatial dependency and sample relationships. Simulation and
prostate cancer data demonstrate its effectiveness. Through our submission of
betaHMM to Bioconductor, we intend to contribute to the open-source software
ecosystem, supporting robust and reproducible data analysis
for both established and emerging biological assays.

This document gives a quick tour of the functionalities in **betaHMM**. See
`help(package="betaHMM")` for further details and references provided by
`citation("betaHMM")`.

# Walk through

## Prerequisites
Before starting the **betaHMM** walk through, the user should have a working
R software environment installed on their machine. The **betaHMM** package has
the following dependencies which, if not already installed on the machine will
automatically be installed along with the package:
**stats, ggplot2, utils,  scales, methods, pROC, foreach, doParallel, cowplot,
dplyr, tidyr, stringr**.


Assuming that the user has the **betaHMM** package installed,
the user first needs to load the package:

```{r package, include=TRUE, echo=TRUE, message=FALSE,warning=FALSE}
library(betaHMM)
```

## Loading the data


## Loading the methylation and annotation data
The **betaHMM** software package offers a pre-processed methylation dataset
containing beta values obtained from DNA samples collected from four patients
with high-grade prostate cancer. These samples encompass both benign and tumor
prostate tissues and were subjected to methylation profiling using Infinium
MethylationEPIC Beadchip technology. The dataset comprises DNA samples from
R = 2 treatment conditions for each of N = 4 patients, with each DNA sample
providing beta values for C = 694,820 CpG sites. This data collection was
part of a study on prostate cancer methylomics (Silva et al. 2020). For
testing purposes, a subset of CpG sites from chromosome 7 has been included
in the package.

This package also provides a subset of the EPIC annotation file, which
users need to input into the **betaHMM** function. Users can load these two
datasets from the package and inspect the first six rows in the dataframes
using the following procedure:

```{r data,include=TRUE, echo=TRUE}
data(pca_methylation_data)
head(pca_methylation_data)
data(annotation_data)
head(annotation_data)


```

## The betaHMM workflow

The betaHMM model, which is employed to identify DMCs (differentially
methylated CpG sites) and DMRs (differentially methylated regions), consists of
three crucial functions. The entire process is carried out separately for each
chromosome and involves the following steps:
\begin{itemize}
    \item the \textbf{betaHMM} function: This function handles model parameter
    and hidden state estimation.It comprises three main steps: initialization,
    the Baum-Welch algorithm, and the Viterbi algorithm.
    \item The \textbf{DMC identification} function: This function utilizes the
    output from the betaHMM and identifies the hidden states that are
    differentially methylated, along with the DMCs themselves. The selection of
    DMCs is based on the area-under-curve (AUC) method.
    \item The \textbf{DMR identification} function: This function operates on
    the output from the DMC identification function. It includes a user-defined
    parameter specifying the minimum number of adjacent CpGs required to form a
    DMR. The output of this function is a dataframe that contains information
    about the number of DMCs within a DMR, the CpG sites involved, and the
    starting and ending locations of the DMR.
\end{itemize}

## Model parameter estimation

The initial phase of the workflow involves employing the Baum-Welch algorithm
to estimate the model parameters. Subsequently, we apply the Viterbi algorithm
to determine the most probable sequence of hidden states.

```{r betaHMM,include=TRUE, echo=TRUE}
M <- 3 ## No. of methylation states in a DNA sample type
N <- 4 ## No. of patients
R <- 2 ## No. of treatment conditions
my.seed <- 321 ## set seed for reproducibility

betaHMM_out <- betaHMM(pca_methylation_data,
                                annotation_data,
                                M = 3,
                                N = 4,
                                R = 2,
                                parallel_process = FALSE,
                                seed = my.seed,
                                treatment_group = c("Benign","Tumour"))
```

## Summary of model parameters
The resulting output of a call to betaHMM is an S4 object of class
betaHMMResults.

```{r betaHMMclass,include=TRUE, echo=TRUE}
class(betaHMM_out)
```

The parameters estimated can be displayed using the following S4 methods:

```{r betaHMMaccessor,include=TRUE, echo=TRUE}
## transition matrix estimated for all chromosomes
A(betaHMM_out)

## Shape parameters estimated for a certain chromosome
phi(betaHMM_out)

## Hidden states assigned to all CpG sites for a certain chromosome
head(hidden_states(betaHMM_out)[["chr 7"]])
```


A summary of the model parameters estimated for each chromosome can be obtained
as below:

```{r betaHMMsummary,include=TRUE, echo=TRUE}
summary(betaHMM_out)
```


## DMC identification

After estimating the parameters and hidden states, we proceed to calculate the
AUC metric, which quantifies the dissimilarities between the cumulative
distributions estimated for each hidden state within each chromosome. A
user-defined threshold for the AUC metric is then applied to identify the most
differentially methylated hidden states. Additionally, we utilize a
user-defined threshold for the measure of uncertainty regarding membership in
these highly differentially methylated hidden states to pinpoint the most
differentially methylated CpG sites.

To access the dataframe containing information about CpG site locations,
methylation values, hidden state assignments, and a flag indicating DMC status,
you can use the S4 `assay` command.

```{r dmc,include=TRUE, echo=TRUE}
dmc_out <- dmc_identification(betaHMM_out)
dmc_df <- assay(dmc_out)
head(dmc_df)
```

## Summary of the DMCs identified

```{r dmcsummary,include=TRUE, echo=TRUE}
summary(dmc_out)
```

## Plot the density estimates of the model parameter estimates


The fitted density estimates, kernel density estimates, and the uncertainty in
the hidden state assignment can be observed using the plot function for the
betaHMM output. Since the parameters are estimated individually for each
chromosome, one can generate plots for each chromosome separately. To specify
the chromosome of interest, the user should utilize the `chromosome` parameter
within the function.

Additionally, the AUC metrics calculated for the hidden states can also be
displayed using the `AUC` parameter. By providing the AUC values obtained
through the `dmc_identification` function as an input parameter, the plot will
depict the AUC metrics corresponding to the selected chromosome in the plot
panels.

```{r betaHMMplot,include=TRUE,echo=TRUE,fig.width=8,fig.height=5,dev='png'}
AUC_chr <- AUC(dmc_out)
plot(betaHMM_out, chromosome = "7", what = "fitted density", AUC = AUC_chr)
```


The visualization of uncertainties in hidden state estimation is accomplished
using a boxplot. Additionally, users have the option to input the threshold of
uncertainty intended for DMC identification into the plotting function. This
allows for the incorporation of the specified threshold into the visualization
of uncertainties.

```{r betaHMMplot2,include=TRUE,echo=TRUE,fig.width=6,fig.height=5,dev='png'}
plot(betaHMM_out, chromosome = "7", what = "uncertainty",
        uncertainty_threshold = 0.2)
```

## DMR identification from DMCs identified


Spatially correlated CpG sites give rise to clusters of CpG sites with similar
methylation states, leading to the formation of biologically significant
regions known as differentially methylated regions (DMRs). To define the number
of adjacent DMCs required to identify a DMR, users can utilize the user-defined
parameter `DMC_count`, which is set to a default value of 2. If no value is
specified, the function automatically identifies regions within a chromosome
containing two or more adjacent DMCs as DMRs.

The DMR location information, along with the DMCs within each DMR, is presented
as an S4 output of class `dmrResults`. Accessing this output can be achieved
using the S4 assay method.

```{r dmr,include=TRUE, echo=TRUE}
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)
dmr_df <- assay(dmr_out)
head(dmr_df)
```

## Summary of the DMRs identified

```{r dmrsummary,include=TRUE, echo=TRUE}
summary(dmr_out)
```


## Plot to visualise the DMCs and DMRs

The S4 plot method has the capability to utilize the output generated by the
`dmc_identification` function for plotting methylation values along with the
uncertainty associated with being identified as a DMC. To create such plots,
users must provide the starting CpG site's IlmnID as an input to the
`start_CpG` parameter. Additionally, the `end_CpG` parameter can either take
the IlmnID of the ending CpG site to be plotted or the number of CpG sites
to be plotted, excluding the starting CpG site.

It is worth noting that even though a CpG site may exhibit a very low
uncertainty in being associated with the hidden state identified as the most
differentially methylated, it might not be selected as a DMC if it falls below
the threshold value set by the user.

```{r dmrplot,include=TRUE,echo=TRUE,fig.width=7,fig.height = 5, dev = 'png'}
plot(dmc_out, start_CpG = "cg17750844", end_CpG = 15)
```

## Threshold identification in DNA samples belonging to a specific condition

The initialization of the intricate \eqn{K} hidden states betaHMM model,
aimed at identifying differentially methylated hidden states across DNA
samples collected from multiple biological conditions, begins with the
utilization of a simpler 3-state betaHMM model for parameter estimation
within a single treatment condition for identifying the 3 known methylation
states (hypomethylation, hemimethylation and hypermethylation). Subsequently,
these estimated parameters are amalgamated to construct the \eqn{3^R} hidden
states parameter model.

The function employed to estimate the 3-state betaHMM also provides an
objective estimation of the threshold methylation value distinguishing the
three methylation states. This function can be executed independently to
analyze the data distribution within DNA samples originating from a single
biological condition.

```{r threshold,include=TRUE, echo=TRUE}
threshold_out <- threshold_identification(pca_methylation_data[,1:5],
                                            package_workflow = FALSE,
                                            annotation_file = annotation_data,
                                            M = 3,
                                            N = 4,
                                            parameter_estimation_only = FALSE,
                                            seed = my.seed)
threshold(threshold_out)
```

## Plotting the results from threshold identification function

```{r thresholdplot,include=TRUE,echo=TRUE,fig.width=5,fig.height=4,dev='png'}
plot(threshold_out, plot_threshold = TRUE, what = "fitted density")
```

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods.R
\docType{methods}
\name{annotatedData}
\alias{annotatedData}
\alias{K}
\alias{N}
\alias{R}
\alias{A}
\alias{phi}
\alias{treatment_group}
\alias{llk}
\alias{tau}
\alias{hidden_states}
\alias{chromosome_number}
\alias{AUC}
\alias{uncertainty}
\alias{model_parameters}
\alias{threshold}
\alias{annotatedData,betaHMMResults-method}
\alias{annotatedData,threshold_Results-method}
\alias{K,RangedSummarizedExperiment-method}
\alias{K,betaHMMResults-method}
\alias{K,dmcResults-method}
\alias{K,threshold_Results-method}
\alias{K,NULL-method}
\alias{N,RangedSummarizedExperiment-method}
\alias{N,betaHMMResults-method}
\alias{N,dmcResults-method}
\alias{N,NULL-method}
\alias{R,RangedSummarizedExperiment-method}
\alias{R,betaHMMResults-method}
\alias{R,dmcResults-method}
\alias{R,NULL-method}
\alias{A,RangedSummarizedExperiment-method}
\alias{A,betaHMMResults-method}
\alias{A,NULL-method}
\alias{tau,RangedSummarizedExperiment-method}
\alias{tau,betaHMMResults-method}
\alias{tau,NULL-method}
\alias{phi,RangedSummarizedExperiment-method}
\alias{phi,betaHMMResults-method}
\alias{phi,threshold_Results-method}
\alias{phi,NULL-method}
\alias{llk,RangedSummarizedExperiment-method}
\alias{llk,betaHMMResults-method}
\alias{llk,NULL-method}
\alias{treatment_group,RangedSummarizedExperiment-method}
\alias{treatment_group,betaHMMResults-method}
\alias{treatment_group,dmcResults-method}
\alias{treatment_group,NULL-method}
\alias{hidden_states,RangedSummarizedExperiment-method}
\alias{hidden_states,betaHMMResults-method}
\alias{hidden_states,threshold_Results-method}
\alias{hidden_states,NULL-method}
\alias{model_parameters,RangedSummarizedExperiment-method}
\alias{model_parameters,threshold_Results-method}
\alias{model_parameters,NULL-method}
\alias{threshold,RangedSummarizedExperiment-method}
\alias{threshold,threshold_Results-method}
\alias{threshold,NULL-method}
\alias{chromosome_number,RangedSummarizedExperiment-method}
\alias{chromosome_number,betaHMMResults-method}
\alias{chromosome_number,dmrResults-method}
\alias{chromosome_number,NULL-method}
\alias{AUC,RangedSummarizedExperiment-method}
\alias{AUC,dmcResults-method}
\alias{AUC,NULL-method}
\alias{uncertainty,RangedSummarizedExperiment-method}
\alias{uncertainty,dmcResults-method}
\alias{uncertainty,NULL-method}
\title{Accessors for the betaHMM package.}
\usage{
annotatedData(object)

K(object)

N(object)

R(object)

A(object)

phi(object)

treatment_group(object)

llk(object)

tau(object)

hidden_states(object)

chromosome_number(object)

AUC(object)

uncertainty(object)

model_parameters(object)

threshold(object)

\S4method{annotatedData}{betaHMMResults}(object)

\S4method{annotatedData}{threshold_Results}(object)

\S4method{K}{RangedSummarizedExperiment}(object)

\S4method{K}{betaHMMResults}(object)

\S4method{K}{dmcResults}(object)

\S4method{K}{threshold_Results}(object)

\S4method{K}{`NULL`}(object)

\S4method{N}{RangedSummarizedExperiment}(object)

\S4method{N}{betaHMMResults}(object)

\S4method{N}{dmcResults}(object)

\S4method{N}{`NULL`}(object)

\S4method{R}{RangedSummarizedExperiment}(object)

\S4method{R}{betaHMMResults}(object)

\S4method{R}{dmcResults}(object)

\S4method{R}{`NULL`}(object)

\S4method{A}{RangedSummarizedExperiment}(object)

\S4method{A}{betaHMMResults}(object)

\S4method{A}{`NULL`}(object)

\S4method{tau}{RangedSummarizedExperiment}(object)

\S4method{tau}{betaHMMResults}(object)

\S4method{tau}{`NULL`}(object)

\S4method{treatment_group}{RangedSummarizedExperiment}(object)

\S4method{treatment_group}{betaHMMResults}(object)

\S4method{treatment_group}{dmcResults}(object)

\S4method{treatment_group}{`NULL`}(object)

\S4method{llk}{RangedSummarizedExperiment}(object)

\S4method{llk}{betaHMMResults}(object)

\S4method{llk}{`NULL`}(object)

\S4method{phi}{RangedSummarizedExperiment}(object)

\S4method{phi}{betaHMMResults}(object)

\S4method{phi}{threshold_Results}(object)

\S4method{phi}{`NULL`}(object)

\S4method{hidden_states}{RangedSummarizedExperiment}(object)

\S4method{hidden_states}{betaHMMResults}(object)

\S4method{hidden_states}{threshold_Results}(object)

\S4method{hidden_states}{`NULL`}(object)

\S4method{chromosome_number}{RangedSummarizedExperiment}(object)

\S4method{chromosome_number}{betaHMMResults}(object)

\S4method{chromosome_number}{dmrResults}(object)

\S4method{chromosome_number}{`NULL`}(object)

\S4method{AUC}{RangedSummarizedExperiment}(object)

\S4method{AUC}{dmcResults}(object)

\S4method{AUC}{`NULL`}(object)

\S4method{uncertainty}{RangedSummarizedExperiment}(object)

\S4method{uncertainty}{dmcResults}(object)

\S4method{uncertainty}{`NULL`}(object)

\S4method{model_parameters}{RangedSummarizedExperiment}(object)

\S4method{model_parameters}{threshold_Results}(object)

\S4method{model_parameters}{`NULL`}(object)

\S4method{threshold}{RangedSummarizedExperiment}(object)

\S4method{threshold}{threshold_Results}(object)

\S4method{threshold}{`NULL`}(object)
}
\arguments{
\item{object}{a \code{betaHMMResults}/ \code{dmcResults}/
\code{threshold_Results} object.}
}
\value{
Output varies depending on the method.
}
\description{
The accessor methods for accessing the betaHMMResults/ dmcResults/
dmrResults/ threshold_Results metadata.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialise_parameters.R
\name{initialise_parameters}
\alias{initialise_parameters}
\title{Initialising the betaHMM model parameters}
\usage{
initialise_parameters(data, M, N, R, seed = NULL)
}
\arguments{
\item{data}{A dataframe of dimension \eqn{C \times (N \times R)} containing
methylation values for \eqn{C} CpG sites from \eqn{R}
treatment groups each having \eqn{N} replicates or each
collected from \eqn{N} patients.}

\item{M}{Number of methylation states to be identified in a DNA sample.}

\item{N}{Number of patients or DNA sample replicates collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{seed}{Seed to allow for reproducibility (default = NULL).}
}
\value{
A list containing:
\itemize{
\item A - The transition matrix for the betaHMM model.
\item tau - The initial distribution for the betaHMM model.
\item phi - The shape parameters for the observation sequence data
in the betaHMM model.}
}
\description{
Initialise the betaHMM model parameters.
}
\details{
Computes the shape parameters using the threshold_function to
initialise the shape parameters of the model.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Viterbi.R
\name{Viterbi}
\alias{Viterbi}
\title{Estimating the hidden states using Viterbi algorithm}
\usage{
Viterbi(data, M, N, R, tau, A, phi, K)
}
\arguments{
\item{data}{A dataframe of dimension \eqn{C \times (N \times R)} containing
methylation values for \eqn{C} CpG sites from \eqn{R}
treatment groups each having \eqn{N} replicates or each
collected from \eqn{N} patients.}

\item{M}{Number of methylation states to be identified
in a single DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{tau}{The initial distribution for the betaHMM model.}

\item{A}{The transition matrix for the betaHMM model.}

\item{phi}{The shape parameters for the observation sequence data
in the betaHMM model.}

\item{K}{The number of hidden states identified using the betaHMM model.}
}
\value{
A vector containing the most probable sequence of the hidden states
of the betaHMM model.
}
\description{
The Viterbi algorithm is used to estimate the most probable
sequence of the hidden states utilizing the betaHMM model
parameters estimated by the Baum-Welch algorithm.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sample_methylation_file.R
\docType{data}
\name{sample_methylation_file}
\alias{sample_methylation_file}
\title{Simulated DNA methylation data}
\format{
A data frame with 100 rows and 9 columns. The data contain no
missing values.
\itemize{
\item{IlmnID: The unique identifier from the Illumina CG database,
i.e. the probe ID.}
\item{Benign_Patient_1: Methylation values from benign tissue from
patient 1.}
\item{Benign_Patient_2: Methylation values from benign tissue from
patient 2.}
\item{Benign_Patient_3: Methylation values from benign tissue from
patient 3.}
\item{Benign_Patient_4: Methylation values from benign tissue from
patient 4.}
\item{Tumour_Patient_1: Methylation values from tumor tissue from
patient 1.}
\item{Tumour_Patient_2: Methylation values from tumor tissue from
patient 2.}
\item{Tumour_Patient_3: Methylation values from tumor tissue from
patient 3.}
\item{Tumour_Patient_4: Methylation values from tumor tissue from
patient 4.}}
}
\usage{
data(sample_methylation_file)
}
\value{
The data frame containing simulated methylation values.
}
\description{
A dataset containing simulated beta methylation values from
\eqn{R=2} sample types (Benign and Tumour), collected from \eqn{N=4}
patients.
}
\details{
The array data were then normalized and and probes located outside
of CpG sites and on the sex chromosome were filtered out. The CpG sites with
missing values were removed from the resulting dataset. A subset of the
complete dataset has been uploaded in the package for testing purposes.
The complete dataset is available on
\href{https://github.com/koyelucd/betaHMM}{GitHub}.
}
\seealso{
\code{\link{sample_annotation_file}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/plot-functions.R,
%   R/plotDMR-functions.R, R/plot_thresholds.R
\name{plot}
\alias{plot}
\alias{plot,betaHMMResults-method}
\alias{plot-methods}
\alias{plot,dmcResults-method}
\alias{plot,threshold_Results-method}
\title{Visualize results from \code{betaHMM}/ \code{dmc_identification}/
\code{threshold_identification} functions.}
\usage{
plot(x, ...)

\S4method{plot}{betaHMMResults}(
  x,
  chromosome = NULL,
  what = c("fitted density", "kernel density", "uncertainty"),
  treatment_group = NULL,
  AUC = NULL,
  uncertainty_threshold = 0.2,
  title = NULL,
  ...
)

\S4method{plot}{dmcResults}(
  x,
  start_CpG = NULL,
  end_CpG = NULL,
  treatment_group = NULL,
  N = NULL,
  title = NULL,
  ...
)

\S4method{plot}{threshold_Results}(x, plot_threshold = TRUE, title = NULL, ...)
}
\arguments{
\item{x}{An object of class
\code{\link[betaHMM:betaHMMResults]{betaHMMResults}}/
\code{\link[betaHMM:dmcResults]{dmcResults}}/
\code{\link[betaHMM:dmcResults]{threshold_Results}} object.}

\item{...}{Other graphics parameters.}

\item{chromosome}{The chromosome number for which the plot is to be
displayed.}

\item{what}{The different plots that can be obtained are either
'fitted density','kernel density' or
'uncertainty' (default = 'fitted density').}

\item{treatment_group}{The names of the different treatment groups
to be displayed in the plot.If no value is passed then the sample names
estimated by the \code{betaHMM} function are used.}

\item{AUC}{The AUC values for that chromosome.}

\item{uncertainty_threshold}{The uncertainty threshold value used for DMC
identification.}

\item{title}{The title that the user wants to display.
If no title is to be displayed the default is 'NULL'.}

\item{start_CpG}{The IlmnID of starting CpG site when plotting the DMCs.}

\item{end_CpG}{The IlmnID of ending CpG site/ the total number
of CpGs to be plotted excluing the starting CpG site when plotting the DMCs.}

\item{N}{The number of DNA samples corresponding to each
treatment group analysed using the betaHMM model. If `NULL`, the value from
\code{betaHMMResults} object is selected.}

\item{plot_threshold}{The "TRUE" option displays the threshold points in the
graph for the 3 state betaHMM model (default = "FALSE").}
}
\value{
This function displays the following plots as requested by the user
when analysing the \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}
output:
\itemize{
\item fitted density estimates - Plot showing the fitted density estimates
of the clustering solution under the optimal model selected.
\item kernel density estimates - Plot showing the kernel density estimates
of the clustering solution under the optimal model selected.
\item uncertainty -  A boxplot showing the uncertainties in the
hidden state estimation.
}

The function displays the  DMCs and DMRs plot from
the \code{\link[betaHMM:dmcResults]{dmcResults}} object.

The function displays the plot for the estimated shape parameters
and threshold for the methylation states in a single DNA treatment condition
from the \code{\link[betaHMM:threshold_Results]{threshold_Results}} object.
}
\description{
Visualize results from \code{betaHMM}/ \code{dmc_identification}/
\code{threshold_identification} functions.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}
\author{
Koyel Majumdar
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods.R
\name{dmc_identification}
\alias{dmc_identification}
\alias{dmc_identification,betaHMMResults-method}
\alias{dmc_identification-methods}
\title{DMC identification from estimated betaHMM model parameters}
\usage{
dmc_identification(betaHMM_object, ...)

\S4method{dmc_identification}{betaHMMResults}(
  betaHMM_object,
  AUC_threshold = 0.8,
  uncertainty_threshold = 0.2,
  ...
)
}
\arguments{
\item{betaHMM_object}{An S4 object of class
\code{\link[betaHMM:betaHMMResults]{betaHMMResults}}}

\item{...}{extra arguments}

\item{AUC_threshold}{The threshold for AUC metric for each chromosome.}

\item{uncertainty_threshold}{The threshold for uncertainty of belonging to
a particular hidden state, for each chromosome.}
}
\value{
An S4 object of class \code{\link[betaHMM:dmcResults]{dmcResults}}.
}
\description{
This is the primary user interface for the
\code{\link[betaHMM:dmc_identification]{dmc_identification}} function.
Generic S4 methods are implemented to identify the DMCs from the estimated
betaHMM model parameters for each chromosome. The supported class is a
 \code{\link[betaHMM:betaHMMResults]{betaHMMResults}} object. The output
 is an S4 object of class of \code{\link[betaHMM:dmcResults]{dmcResults}}.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}
\seealso{
\code{\link{betaHMM}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/summary-functions.R
\name{summary}
\alias{summary}
\alias{summary,betaHMMResults-method}
\alias{summary-methods}
\alias{summary,dmcResults-method}
\alias{summary,dmrResults-method}
\title{Summarize results from the three betaHMM workflow functions}
\usage{
summary(object, ...)

\S4method{summary}{betaHMMResults}(object, ...)

\S4method{summary}{dmcResults}(object, ...)

\S4method{summary}{dmrResults}(object, ...)
}
\arguments{
\item{object}{An object of class \code{'betaHMMResults'} or
\code{'dmcResults'} or \code{'dmrResults'}.}

\item{...}{Additional arguments}
}
\value{
Summary of the \code{'betaHMMResults'} or
\code{'dmcResults'} or \code{'dmrResults'} object.
}
\description{
A function to summarize the \code{betaHMMResults}, \code{dmcResults} or
\code{dmrResults} objects.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}
\seealso{
\code{\link{betaHMM}}, \code{\link{dmc_identification}},
\code{\link{dmr_identification}}
}
\author{
Koyel majumdar
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{betaHMMResults-class}
\alias{betaHMMResults-class}
\alias{betaHMMResults}
\title{betaHMMResults object and constructor}
\usage{
betaHMMResults(SummarizedExperiment, annotatedData)
}
\arguments{
\item{SummarizedExperiment}{a \code{RangedSummarizedExperiment} of
\code{betaHMM} results}

\item{annotatedData}{The annotated data passed as an input argument to
the betaHMM package.}
}
\value{
a betaHMMResults object
}
\description{
\code{betaHMMResults} is a subclass of \code{RangedSummarizedExperiment},
used to store the betaHMM results as well as the annotated data useful
 for plotting.
}
\details{
This constructor function would not typically be used by "end users".
This simple class extends the \code{RangedSummarizedExperiment} class of the
SummarizedExperiment package
to allow other packages to write methods for results
objects from the betaHMM package. It is used by
to wrap up the results table.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/threshold_identification.R
\name{threshold_identification_run}
\alias{threshold_identification_run}
\title{Threshold indentification function}
\usage{
threshold_identification_run(
  data,
  package_workflow = TRUE,
  annotation_file = NULL,
  M,
  N,
  parameter_estimation_only = FALSE,
  seed = NULL,
  ...
)
}
\arguments{
\item{data}{Methylation data and IlmnID. Maybe provided as
a matrix or dataframe.}

\item{package_workflow}{Flag set to TRUE if method called from package
workflow.
If set to FALSE then the parameter annotation_file needs to be supplied to
the function.}

\item{annotation_file}{A dataframe containing the EPIC methylation
annotation file.}

\item{M}{Number of methylation states to be identified in a
single DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{parameter_estimation_only}{If only model parameters are to be
estimated then value is TRUE else FALSE.}

\item{seed}{Seed to allow for reproducibility (default = NULL).}

\item{...}{Extra parameters.}
}
\value{
An S4 object of class \code{threshold_Results}, where conditional
probabilities
of each CpG site belonging to a one of the \eqn{M} methylation states
is stored as a SimpleList of
assay data, and the corresponding estimated model parameters, the thresholds
and most probable hidden state sequence for each chromosome are
stored as metadata.
}
\description{
HMM for beta valued DNA data for a single treatment condition
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)
library(betaHMM)

## read files
data(sample_methylation_file)
head(sample_methylation_file)
data(sample_annotation_file)
head(sample_annotation_file)
##merge data
df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
sample_methylation_file,by='IlmnID')

## sort data
df=df[order(df$CHR,df$MAPINFO),]
thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
parameter_estimation_only=TRUE,seed=12345)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BaumWelch.R
\name{BaumWelch}
\alias{BaumWelch}
\title{HMM parameter estimation using Baum-Welch algorithm}
\usage{
BaumWelch(
  data,
  trained_params = NULL,
  K,
  M,
  N,
  R,
  seed = NULL,
  iterations = 100
)
}
\arguments{
\item{data}{A dataframe of dimension \eqn{C \times (N \times R)} containing
methylation values for \eqn{C} CpG sites from \eqn{R}
treatment groups each having \eqn{N} DNA samples.}

\item{trained_params}{A list containing the initialized model parameters:
\itemize{
\item A - The transition matrix for the betaHMM model.
\item tau - The initial distribution for the betaHMM model.
\item phi - The shape parameters for the observation sequence data
in the betaHMM model.}}

\item{K}{The number of hidden states identified using the betaHMM model.}

\item{M}{Number of methylation states to be identified in a single
DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{seed}{Seed to allow for reproducibility (default = NULL).}

\item{iterations}{Number of iterations for algorithm convergence.}
}
\value{
A list containing:
\itemize{
\item A - The transition matrix estimated for the betaHMM model.
\item tau - The initial distribution estimated for the betaHMM model.
\item phi - The shape parameters estimated for the observed data
in the betaHMM model.
\item log_vec - A vector containing the log-likelihood values
calculated for each iteration of the algorithm.
\item z - A matrix of dimension \eqn{C \times K} containing the
conditional posterior probability of each CpG site belonging to each of
the \eqn{K} hidden states.
}
}
\description{
The function determines the parameters of a homogeneous
beta hidden Markov model (betaHMM), wherein the Baum-Welch algorithm
constitutes a variant of the EM (Estimation-Maximization) procedure.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general-functions.R
\name{betaHMMrun}
\alias{betaHMMrun}
\title{The betaHMM model parameter estimation function}
\usage{
betaHMMrun(
  methylation_data,
  annotation_file,
  M,
  N,
  R,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)
}
\arguments{
\item{methylation_data}{A dataframe of dimension \eqn{(C \times (N \times R)
)+1} containing methylation values for \eqn{C} CpG sites from \eqn{R}
treatment groups each having \eqn{N} DNA samples and the IlmnID
for each CpG site.}

\item{annotation_file}{A dataframe containing the EPIC methylation
annotation file.}

\item{M}{Number of methylation states to be identified in a
single DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{treatment_group}{The names of each treatment groups/
conditions. If no value is passed then default values of sample names,
e.g. Sample 1, Sample 2, etc are used as legend text (default = NULL).}

\item{parallel_process}{The 'TRUE' option results in parallel processing of
the models for each chromosome for increased computational efficiency.
The default option has been set as 'FALSE' due to package testing
limitations.}

\item{seed}{Seed to allow for reproducibility (default = NULL).}

\item{iterations}{Number of iterations for algorithm convergence
(default=100).}

\item{...}{Extra arguments}
}
\value{
The function returns an object of the
\code{\link[betaHMM:betaHMMResults]{betaHMMResults}} class
which contains a SimpleList of assay data containing the posterior
probability of each CpG site belonging to each of the
\eqn{K} hidden states and the following values as metadata:
\itemize{
\item K - The number of hidden states identified using the betaHMM model.
\item C - The number of CpG sites analysed using the betaHMM model.
\item N - The number of DNA samples corresponding to each
treatment group analysed using the betaHMM model.
\item R - The number of treatment groups analysed using the betaHMM model.
\item A - The transition matrix estimated for the betaHMM model.
\item tau - The initial distribution estimated for the betaHMM model.
\item treatment_group - The names of the treatment
groups/conditions analysed.
\item phi - The shape parameters estimated for the observed data
in the betaHMM model.
\item llk - A vector containing the log-likelihood values calculated
for each iteration of the algorithm.
\item hidden_states - The vector containing the estimated hidden states
for each CpG sites. }
}
\description{
A homogeneous hidden Markov model for the beta valued DNA
methylation data.
}
\details{
The betaHMM function employs initially set parameters (utilizing a
basic 3-state beta hidden Markov model) to estimate the parameters of the
homogeneous hidden Markov model, adapted for beta-valued DNA methylation
data, through implementation of the Baum-Welch algorithm. Subsequently,
the derived parameters are utilized to ascertain the most probable sequence
of hidden states using the Viterbi algorithm.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general-functions.R
\name{dmc_identification_run}
\alias{dmc_identification_run}
\title{DMC identification from estimated betaHMM model parameters}
\usage{
dmc_identification_run(
  betaHMM_object,
  AUC_threshold = 0.8,
  uncertainty_threshold = 0.2,
  ...
)
}
\arguments{
\item{betaHMM_object}{A \code{\link[betaHMM:betaHMMResults]{betaHMMResults}}
object.}

\item{AUC_threshold}{The threshold for AUC metric for each chromosome.}

\item{uncertainty_threshold}{The threshold for uncertainty of belonging to
a particular hidden state, for each chromosome.}

\item{...}{extra arguments}
}
\value{
The function returns an object of the
\code{\link[betaHMM:dmcResults]{dmcResults}} class
which contains a SimpleList of assay data which contains the
following values:
\itemize{
\item CHR Chromosome number
\item MAPINFO Mapinfo
\item IlmnID IlmnID
\item N*R columns containing methylation states
\item hidden_state The assigned hidden_state
\item DMC The value is 1 if the CpG is a DMC else 0.}
The object contains the following values as the metadata:
\itemize{
\item A list containing the AUC values for K hidden states for each
chromosome and the conditions compared which resulted in the highest AUC
value when more than 2 conditions are compared.
\item A list containing the conditional probability values for K hidden
states for each chromosome.
\item The treatment group labels.
\item K The number of hidden states estimated.
\item N The number of DNA replicates/patients for each treatment group.
\item R The number of treatment groups to be compared.
}
}
\description{
The dissimilarities between the cumulative distributions
calculated for each hidden state are determined through employment of the
area-under-curve (AUC) technique. By incorporating user-defined threshold
values for AUC alongside the associated uncertainties in membership within
that hidden state, the aim is to pinpoint the most distinctively methylated
states. This process facilitates the identification of CpGs that exhibit the
most notable differential methylation, guided by the predefined threshold
criteria.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pca_methylation_data.R
\docType{data}
\name{pca_methylation_data}
\alias{pca_methylation_data}
\title{Simulated DNA methylation data}
\format{
A data frame with 38672 rows and 9 columns. The data contain no
missing values.
\itemize{
\item{IlmnID: The unique identifier from the Illumina CG database,
i.e. the probe ID.}
\item{Benign_Patient_1: Methylation values from benign tissue from
patient 1.}
\item{Benign_Patient_2: Methylation values from benign tissue from
patient 2.}
\item{Benign_Patient_3: Methylation values from benign tissue from
patient 3.}
\item{Benign_Patient_4: Methylation values from benign tissue from
patient 4.}
\item{Tumour_Patient_1: Methylation values from tumor tissue from
patient 1.}
\item{Tumour_Patient_2: Methylation values from tumor tissue from
 patient 2.}
 \item{Tumour_Patient_3: Methylation values from tumor tissue from
 patient 3.}
 \item{Tumour_Patient_4: Methylation values from tumor tissue from
 patient 4.}}
}
\usage{
data(pca_methylation_data)
}
\value{
A data frame containing a subset of methylation data
from real study.
}
\description{
A subset of the dataset containing beta methylation values from
\eqn{R=2} sample types (Benign and Tumour), collected from \eqn{N=4}
patients from the a prostate cancer study. The dataset contains methylation
values corresponding to chromosome 7.
}
\details{
The array data were then normalized and and probes located outside
of CpG sites and on the sex chromosome were filtered out. The CpG sites with
missing values were removed from the resulting dataset. A subset of the
complete dataset has been uploaded in the package for testing purposes.
The complete dataset is available on
\href{https://github.com/koyelucd/betaclust}{GitHub}.
}
\seealso{
\code{\link{annotation_data}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forward.R
\name{forward}
\alias{forward}
\title{Forward algorithm}
\usage{
forward(probabilities, trained_params)
}
\arguments{
\item{probabilities}{A matrix containing the marginal probability
distribution of the \eqn{K} states within the Markov model.}

\item{trained_params}{A list containing the initialised shape parameters for
the betaHMM model (initial distribution, transition matrix, shape parameters
for the observed data).}
}
\value{
A list containing:
\itemize{
\item log_alpha - A \eqn{C*K} matrix (where \eqn{C} is the number of CpG
sites and \eqn{K} is the number of hidden states) containing the
logarithmized forward probabilities.
\item scaled_logL - The log-likelihood calculated using the forward
probabilities.}
}
\description{
Computes the forward probabilities for \eqn{K} hidden states
using the initial distribution, transition matrix and distribution
parameters.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general-functions.R
\name{dmr_identification_run}
\alias{dmr_identification_run}
\title{DMR identification from DMCs identified}
\usage{
dmr_identification_run(
  dmc_identification_object,
  DMC_count = 2,
  parallel_process = FALSE,
  ...
)
}
\arguments{
\item{dmc_identification_object}{a \code{dmcResults} object or
the assay data from the dmcResults.}

\item{DMC_count}{The minimal number of consecutive CpGs in a DMR.}

\item{parallel_process}{The 'TRUE' option results in parallel processing of
the DMCs from each chromosome for increased computational efficiency.
The default option has been set as 'FALSE' due to package testing
limitations.}

\item{...}{extra arguments}
}
\value{
A \code{\link[betaHMM:dmrResults]{dmrResults}}
object containing a SimpleList of assay data containing the following data:
\itemize{
\item start_CpG - The starting CpG site IlmnID in the particular DMR
\item end_CpG -  The ending CpG site IlmnID in the particular DMR
\item DMR_size - Number of CPG sites identified in the DMR
\item chr_dmr - The chromosome corresponding to the CpG sites in the DMR.
\item map_start - MAPINFO of starting CpG site in the particular DMR
\item map_end -  MAPINFO of the ending CpG site in the particular DMR}
The object also returns the chromosomes analysed by the betaHMM model as
the metadata.
}
\description{
Function to identify the DMRs from the DMCs identified in each
chromosome.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods.R
\name{threshold_identification}
\alias{threshold_identification}
\alias{threshold_identification,matrix-method}
\alias{threshold_identification-methods}
\alias{threshold_identification,data.frame-method}
\title{HMM for beta valued DNA data for a single treatment condition}
\usage{
threshold_identification(object1, ...)

\S4method{threshold_identification}{matrix}(
  object1,
  package_workflow = TRUE,
  annotation_file = NULL,
  M = 3,
  N = 4,
  parameter_estimation_only = FALSE,
  seed = NULL,
  ...
)

\S4method{threshold_identification}{data.frame}(
  object1,
  package_workflow = TRUE,
  annotation_file = NULL,
  M = 3,
  N = 4,
  parameter_estimation_only = FALSE,
  seed = NULL,
  ...
)
}
\arguments{
\item{object1}{Methylation data and IlmnID. Maybe provided as a matrix
or dataframe.}

\item{...}{Extra parameters.}

\item{package_workflow}{Flag set to TRUE if method called from package
workflow.
If set to FALSE then the parameter annotation_file needs to be supplied to
the function.}

\item{annotation_file}{A dataframe containing the EPIC methylation
annotation file.}

\item{M}{Number of methylation states to be identified in a
single DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{parameter_estimation_only}{If only model parameters are to be
estimated then value is TRUE else FALSE.}

\item{seed}{Seed to allow for reproducibility (default = NULL).}
}
\value{
An S4 object of class \code{threshold_Results}.
}
\description{
The supported classes are \code{matrix} and \code{data.frame}.
The output of \code{threshold_identification} is an S4 object of
class \code{threshold_Results}.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)
library(betaHMM)

## read files
data(sample_methylation_file)
head(sample_methylation_file)
data(sample_annotation_file)
head(sample_annotation_file)
##merge data
df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
sample_methylation_file,by='IlmnID')

## sort data
df=df[order(df$CHR,df$MAPINFO),]
thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
parameter_estimation_only=TRUE,seed=12345)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/backward.R
\name{backward}
\alias{backward}
\title{Backward algorithm}
\usage{
backward(probabilities, trained_params)
}
\arguments{
\item{probabilities}{A matrix containing the marginal probability
distribution of the \eqn{K} hidden states within the Markov model.}

\item{trained_params}{A list containing the initialised shape parameters for
the betaHMM model (initial distribution, transition matrix, shape parameters
for the observed data).}
}
\value{
A list containing:
\itemize{
\item log_beta - A matrix of dimension \eqn{C*K} (where \eqn{C} is the
number of CpG sites and \eqn{K} is the number of hidden states) containing
the logarithmized backward probabilities.
\item scaled_logL - The log-likelihood calculated using the backward
probabilities.
}
}
\description{
Computes the backward probabilities for \eqn{K} hidden states
using the initial distribution, transition matrix and distribution
parameters.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods.R
\name{dmr_identification}
\alias{dmr_identification}
\alias{dmr_identification,dmcResults-method}
\alias{dmr_identification-methods}
\alias{dmr_identification,matrix-method}
\alias{dmr_identification,data.frame-method}
\title{DMR identification from DMCs identified}
\usage{
dmr_identification(dmc_identification_object, ...)

\S4method{dmr_identification}{dmcResults}(dmc_identification_object, DMC_count = 2, ...)

\S4method{dmr_identification}{matrix}(dmc_identification_object, DMC_count = 2, ...)

\S4method{dmr_identification}{data.frame}(dmc_identification_object, DMC_count = 2, ...)
}
\arguments{
\item{dmc_identification_object}{a
\code{\link[betaHMM:dmcResults]{dmcResults}} object or the assay data
from the dmcResults.}

\item{...}{extra arguments}

\item{DMC_count}{The minimal number of consecutive CpGs in a DMR.}
}
\value{
An S4 object of class \code{\link[betaHMM:dmrResults]{dmrResults}}
where the CpG site information for each DMR is stored as a SimpleList
of assay data and the chromosomes analysed by the model is stored as
the metadata.
}
\description{
This is the primary user interface for the
\code{\link[betaHMM:dmr_identification]{dmr_identification}} function.
Generic S4 methods are implemented to identify the DMRs from the DMCs
identified in each chromosome. The supported classes are \code{data.frame}
and \code{\link[betaHMM:dmcResults]{dmcResults}} object. The output is an
S4 object of class \code{\link[betaHMM:dmrResults]{dmrResults}}.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}
\seealso{
\code{\link{betaHMM}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sample_annotation_file.R
\docType{data}
\name{sample_annotation_file}
\alias{sample_annotation_file}
\title{MethylationEPIC manifest data.}
\format{
A data frame with 100 rows and 9 columns.
\itemize{
        \item{IlmnID: The unique identifier from the Illumina CG database,
        i.e. the probe ID.}
        \item{Genome_Build: The genome build referenced by the Infinium
        MethylationEPIC manifest.}
        \item{CHR: The chromosome containing the CpG (Genome_Build = 37).}
        \item{MAPINFO: The chromosomal coordinates of the CpG sites.}
        \item{UCSC_RefGene_Name: The target gene name(s), from the UCSC
        database. Note: multiple listings of the same gene name indicate
        splice variants.}
        \item{UCSC_RefGene_Accession: The UCSC accession numbers of the
        target transcripts. Accession numbers are in the same order as the
        target gene transcripts.}
        \item{UCSC_RefGene_Group: Gene region feature category describing
        the CpG position, from UCSC. Features are listed in the same order
        as the target gene transcripts.}
        \item{UCSC_CpG_Islands_Name: The chromosomal coordinates of the CpG
        Island from UCSC.}
        \item{Relation_to_UCSC_CpG_Island: The location of the CpG relative
        to the CpG island.}
        }
}
\usage{
data(sample_annotation_file)
}
\value{
A data frame containing the array design for Illumina’s
Human Methylation EPIC microarray for the simulated CpG sites.
Based on the v1.0b2 version of the manifest file.
}
\description{
A dataset containing a subset of the manifest data from the
Illumina MethylationEPIC beadchip array. A subset of the complete dataset
has been uploaded in the package for testing purpose. The complete dataset
is available on \href{https://github.com/koyelucd/betaHMM}{GitHub}.
}
\seealso{
\code{\link{sample_methylation_file}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AUC_DM_analysis.R
\name{AUC_DM_analysis}
\alias{AUC_DM_analysis}
\title{Area under the curve method for calculating dissimilarities between
estimated distributions}
\usage{
AUC_DM_analysis(M, N, R, K, tau, A, phi)
}
\arguments{
\item{M}{Number of methylation states to be identified in a single DNA
sample.}

\item{N}{Number of patients or DNA sample replicates collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{K}{Number of hidden states estimated.}

\item{tau}{The initial distribution for hidden states in the betaHMM model.}

\item{A}{The transition matrix for hidden states in the betaHMM model.}

\item{phi}{The shape parameters estimated for the observed data and the
estimated hidden states in the betaHMM model.}
}
\value{
A dataframe returning the hidden state, the AUC value and the
distributions which resulted in highest AUC value calculated
for the corresponding hidden state.
}
\description{
The function is used to calculate the dissimilarity between the
cumulative distributions estimated in each hidden state.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods.R
\docType{methods}
\name{betaHMM}
\alias{betaHMM}
\alias{betaHMM,matrix,matrix-method}
\alias{betaHMM-methods}
\alias{betaHMM,data.frame,data.frame-method}
\alias{betaHMM,RangedSummarizedExperiment,RangedSummarizedExperiment.-method}
\alias{betaHMM,matrix,data.frame-method}
\alias{betaHMM,matrix,RangedSummarizedExperiment.-method}
\alias{betaHMM,data.frame,matrix-method}
\alias{betaHMM,data.frame,RangedSummarizedExperiment.-method}
\alias{betaHMM,RangedSummarizedExperiment,data.frame-method}
\alias{betaHMM,RangedSummarizedExperiment,matrix-method}
\alias{betaHMM,GRanges,data.frame-method}
\alias{betaHMM,GRanges,matrix-method}
\alias{betaHMM,GRanges,RangedSummarizedExperiment-method}
\alias{betaHMM,GRanges,GRanges-method}
\alias{betaHMM,data.frame,GRanges-method}
\alias{betaHMM,RangedSummarizedExperiment,GRanges-method}
\alias{betaHMM,matrix,GRanges-method}
\alias{betaHMM,RangedSummarizedExperiment,RangedSummarizedExperiment-method}
\alias{betaHMM,matrix,RangedSummarizedExperiment-method}
\alias{betaHMM,data.frame,RangedSummarizedExperiment-method}
\title{HMM for beta valued DNA data}
\usage{
betaHMM(methylation_data, annotation_file, ...)

\S4method{betaHMM}{matrix,matrix}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{data.frame,data.frame}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{RangedSummarizedExperiment,RangedSummarizedExperiment}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{GRanges,GRanges}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{RangedSummarizedExperiment,matrix}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{RangedSummarizedExperiment,data.frame}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{RangedSummarizedExperiment,GRanges}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{matrix,RangedSummarizedExperiment}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{data.frame,RangedSummarizedExperiment}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{data.frame,GRanges}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{matrix,data.frame}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{matrix,GRanges}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{GRanges,matrix}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{GRanges,data.frame}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{GRanges,RangedSummarizedExperiment}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)

\S4method{betaHMM}{data.frame,matrix}(
  methylation_data,
  annotation_file,
  M = 3,
  N = 4,
  R = 2,
  treatment_group = NULL,
  parallel_process = FALSE,
  seed = NULL,
  iterations = 100,
  ...
)
}
\arguments{
\item{methylation_data}{A dataframe of dimension \eqn{(C \times (N \times R)
)+1} containing methylation values for \eqn{C} CpG sites from \eqn{R}
treatment groups each having \eqn{N} DNA samples and the IlmnID
for each CpG site. Maybe provided as a matrix or data.frame, GRanges
or RangedSummarizedExperiment object.}

\item{annotation_file}{A dataframe containing the EPIC methylation
annotation file. Maybe provided as a matrix or data.frame, GRanges
or RangedSummarizedExperiment object.}

\item{...}{Extra arguments}

\item{M}{Number of methylation states to be identified in a
single DNA sample.}

\item{N}{Number of DNA samples (patients/replicates) collected for each
treatment group.}

\item{R}{Number of treatment groups (For. eg: Benign and Tumour).}

\item{treatment_group}{The names of each treatment groups/
conditions. If no value is passed then default values of sample names,
e.g. Sample 1, Sample 2, etc are used as legend text (default = NULL).}

\item{parallel_process}{The 'TRUE' option results in parallel processing of
the models for each chromosome for increased computational efficiency.
The default option has been set as 'FALSE' due to package testing
limitations.}

\item{seed}{Seed to allow for reproducibility (default = NULL).}

\item{iterations}{Number of iterations for algorithm convergence
(default=100).}
}
\value{
An S4 object of class \code{betaHMMResults}, where conditional
probabilities of each CpG site belonging to a hidden state is stored as a
SimpleList of assay data, and the corresponding estimated model parameters,
log-likelihood values, and most probable hidden state sequence for each
chromosome are stored as metadata.
}
\description{
This is the primary user interface for the \code{betaHMM} function
Generic S4 methods are implemented to eatimate the parameters of a
homogeneous hidden Markov model for the beta valued DNA methylation data.
The supported classes are \code{matrix}, \code{data.frame},
\code{RangedSummarizedExperiment} and \code{GRanges}. The output of
\code{betaHMM} method is an
S4 object of class \code{betaHMMResults}.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)

## read files
data(sample_methylation_file)
data(sample_annotation_file)
# Run betaHMM function
beta_out <- betaHMM(sample_methylation_file[1:50,],
                    sample_annotation_file[1:50,],
                    M = 3, N = 4, R = 2,iterations=2,
                    parallel_process = FALSE, seed = 12345,
                    treatment_group = c("Benign","Tumour"))

## Run dmc_identification function
dmc_out <- dmc_identification(beta_out)

# Run dmr_identification function
dmr_out <- dmr_identification(dmc_out, parallel_process = FALSE)

# Plot functions
# Get the AUC values calculated for each hidden state
AUC_chr <- AUC(dmc_out)

## plot the uncertainty for each hidden state
plot(beta_out, chromosome = "1", what = "uncertainty")

}
\author{
Koyel Majumdar
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{threshold_Results-class}
\alias{threshold_Results-class}
\alias{threshold_Results}
\title{threshold_Results object and constructor}
\usage{
threshold_Results(SummarizedExperiment, annotatedData)
}
\arguments{
\item{SummarizedExperiment}{a \code{RangedSummarizedExperiment} of
\code{threshold_Results} object.}

\item{annotatedData}{The annotated data passed as an input argument to
the \code{threshold_identification} function.}
}
\value{
a \code{\link[betaHMM:threshold_Results]{threshold_Results}} object
}
\description{
\code{threshold_Results} is a subclass of \code{RangedSummarizedExperiment},
used to store the threshold_identification results as well as the annotated
 data useful for plotting.
}
\details{
This constructor function would not typically be used by "end users".
This simple class extends the \code{RangedSummarizedExperiment} class of the
SummarizedExperiment package
to allow other packages to write methods for results
objects from the
\code{\link[betaHMM:threshold_identification]{threshold_identification}}
function. It is used by
to wrap up the results table.
}
\examples{
## Use simulated data for the betaHMM workflow example
set.seed(12345)
library(betaHMM)

## read files
data(sample_methylation_file)
head(sample_methylation_file)
data(sample_annotation_file)
head(sample_annotation_file)
##merge data
df=merge(sample_annotation_file[,c('IlmnID','CHR','MAPINFO')],
sample_methylation_file,by='IlmnID')

## sort data
df=df[order(df$CHR,df$MAPINFO),]
thr_out=threshold_identification(df[,c(1,4:7)],package_workflow=TRUE,M=3,4,
parameter_estimation_only=TRUE,seed=12345)

}
